/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/


/* ***********************************************************************************************
*dicButton.c													
*(c)Eduardo Rodriguez 2005																
*																					
*porpuse:   This creates the buttons that emerge as new rimes are added. The have to fundamental
*           states, closed and open. 
*          
*history:	21/09/2005 created															
*********************************************************************************************** */


#include <windows.h>
#include <stdio.h>
#include "MEDicBut.h"
#include "controles/MEControls.h"
#include "buttonManager.h"
#include "editURL.h"
#include "searcher.h"
/*************************
*DATA MEMBERS
**************************/

//constants

#define ASONANTE 0
#define CONSONANTE 1
#define FNV         2
#define FVP         3
#define FVNP        4
#define SAVE        5
#define CLOSE       6
#define OPEN        7
#define DESTROY     8





//info for every instance
typedef struct _dicButtonStruc
{
    int posX;
    int posY;
    int width;
    int height;
    int over;
    int pressed;
    int currentHeight;
    int top;
    int sil;
    int VoH; 
    BOOL consonante;
    int forma;   
    BOOL open;
    HWND hwnd;
    HWND thisone;
    HWND eURL;
    int ttids[8];
    BOOL ready;
    char* word;       
}dicButtonStruc;

static int mHeight=0;
HWND openDic=NULL;
const char g_dicButtonName[]="dicButton";
static const char silchar[10][5]={" n/a\0","   1\0","   2\0","   3\0","   4\0","   5\0","   6\0","   7\0","   8\0","   9\0"}; 
static const char VoHchar[3][5]={" n/a\0"," VoH\0"," con\0"};
extern HBITMAP bm;
extern HDC memdc;


//////////////////////////////////////////////////////////////////////////////////////
/*********************************METHODS ("PRIVATE")*******************************/
/////////////////////////////////////////////////////////////////////////////////////


static dicButtonStruc*  GetDicButtonStruc(HWND hwnd)
{
    return (dicButtonStruc *)GetWindowLong(hwnd, 0);
}

static void SetDicButtonStruc(HWND hwnd, dicButtonStruc *ccp)
{
    SetWindowLong(hwnd, 0, (LONG)ccp);
}



static void initTTBut(HWND hwnd,dicButtonStruc* ccp)
{
       int butspace=(ccp->width-153)/4;
       ccp->ttids[0]=addToolTip(hwnd,ccp->width-22, 2,20,20,"Haz click aqu para borrar esta bsqueda\n");  
       ccp->ttids[1]=addToolTip(hwnd,ccp->width-44, 2,20,20,"Haz click aqu para minimizar esta bsqueda\n");  
       ccp->ttids[2]=addToolTip(hwnd,ccp->width-66, 2,20,20,"Haz click aqu para guardar la categora \nvisible en un archivo de texto\n");  
       ccp->ttids[3]=addToolTip(hwnd,0,30,64,20,"Muestra las rimas consonantes\n");  
       ccp->ttids[4]=addToolTip(hwnd,65,30,65,20,"Muestra las rimas asonantes\n");  
       ccp->ttids[5]=addToolTip(hwnd,butspace, 60,51,19 ,"Muestra las formas no verbales\n");  
       ccp->ttids[6]=addToolTip(hwnd,butspace*2+51, 60,51,19,"Muestra las formas verbales personales\n");  
       ccp->ttids[7]=addToolTip(hwnd, butspace*3+102, 60,51,19 ,"Muestra las formas verbales impersonales \n(participios, enclticas, etc)\n");  
             
}

static void destroyTT(HWND hwnd,dicButtonStruc* ccp)
{
   int kk;
   for(kk=0;kk<8;kk++)
   destroyToolTip(ccp->ttids[kk]);      
       
}




/***************************
*PAINT
****************************/

static void paintDicButton(HWND hwnd,dicButtonStruc* ccp)
{
    //blablabla
    PAINTSTRUCT Ps;
    HDC hDC = BeginPaint(hwnd, &Ps);
    HDC MemDC= CreateCompatibleDC(hDC);
    HFONT hf = CreateFont(ccp->height-4, 6, 0, 0,400, 0, 0, 0, 0, 0, 0, 0, 0, "Times New Roman");   
    COLORREF c1,c2,c3,c4,c5;
    HBRUSH bk1,bk2;
    HPEN p1,p2;
    SIZE size;
    char word[100];
    int kk;
    int butspace=0;
    SelectObject(MemDC,bm);
    int offset;
    
    //get colors for bg
    c1=GetPixel(MemDC,4,0);
    c2=GetPixel(MemDC,5,0);
    c3=GetPixel(MemDC,6,0);
    c4=GetPixel(MemDC,7,0);
    c5=GetPixel(MemDC,11,0);
    bk1=CreateSolidBrush(c2);
    p1=CreatePen(PS_SOLID, 1, c1);
    bk2=CreateSolidBrush(c4);
    p2=CreatePen(PS_SOLID, 1, c3);
      
    
    //paint first bg
    SelectObject(memdc,bk1);
    SelectObject(memdc,p1);
    if(ccp->open)
    offset=ccp->height*3;
    else
    offset=ccp->height;
    Rectangle(memdc,0,0,ccp->width,offset);

    //paint destroy button
    if(ccp->over!=DESTROY && ccp->pressed!=DESTROY)
        BitBlt(memdc, ccp->width-22, 2,20,20 , MemDC, 11, 108, SRCCOPY); 
    else if(ccp->pressed==DESTROY)
        BitBlt(memdc, ccp->width-22, 2,20,20 , MemDC, 11, 148, SRCCOPY); 
    else if(ccp->over==DESTROY)
        BitBlt(memdc, ccp->width-22, 2,20,20 , MemDC, 11, 128, SRCCOPY); 
        
    //paint open
    if(ccp->over!=OPEN && ccp->pressed!=OPEN && !ccp->open)
        BitBlt(memdc, ccp->width-44, 2,20,20 , MemDC, 31, 108, SRCCOPY); 
    else if(ccp->pressed==OPEN)
        BitBlt(memdc, ccp->width-44, 2,20,20 , MemDC, 31, 148, SRCCOPY); 
    else if(ccp->over==OPEN)
        BitBlt(memdc, ccp->width-44, 2,20,20 , MemDC, 31, 128, SRCCOPY); 
        
    //paint close
    else if(ccp->over!=CLOSE && ccp->pressed!=CLOSE)
        BitBlt(memdc, ccp->width-44, 2,20,20 , MemDC, 51, 108, SRCCOPY); 
    else if(ccp->pressed==CLOSE)
        BitBlt(memdc, ccp->width-44, 2,20,20 , MemDC, 51, 148, SRCCOPY); 
    else if(ccp->over==CLOSE)
        BitBlt(memdc, ccp->width-44, 2,20,20 , MemDC, 51, 128, SRCCOPY); 

    //paint save
    if(ccp->over!=SAVE && ccp->pressed!=SAVE && ccp->open)
        BitBlt(memdc, ccp->width-66, 2,20,20 , MemDC, 71, 108, SRCCOPY); 
    else if(ccp->pressed==SAVE && ccp->open)
        BitBlt(memdc, ccp->width-66, 2,20,20 , MemDC, 71, 148, SRCCOPY); 
    else if(ccp->over==SAVE && ccp->open)
        BitBlt(memdc, ccp->width-66, 2,20,20 , MemDC, 71, 128, SRCCOPY); 
    else 
        BitBlt(memdc, ccp->width-66, 2,20,20 , MemDC, 71, 168, SRCCOPY); 
 
        
    //write the word
    SetBkColor(memdc, c2);
    SetTextColor(memdc, c1);
    SelectObject(memdc,hf);
    

    //write word
    RECT rec;
    rec.top=2;
    rec.bottom=ccp->height-2;
    rec.left=5;
    rec.right=ccp->width-72;
      //build string
      memset(word,'\0',100);
      sprintf(word,"%s%s",silchar[ccp->sil],VoHchar[ccp->VoH]);
      GetTextExtentPoint32(memdc,ccp->word,strlen(ccp->word),&size);
    DrawText(memdc,ccp->word,strlen(ccp->word),&rec,DT_END_ELLIPSIS); 
    rec.left=size.cx+8;
    rec.right=ccp->width-72;
    SetTextColor(memdc,c5); 
    
    if(ccp->ready)
        DrawText(memdc,word,strlen(word),&rec,DT_END_ELLIPSIS);   
    else
        DrawText(memdc,"buscando",8,&rec,DT_END_ELLIPSIS);      


    //if opem
    if(ccp->open)
    {
        //paint 2nd bg
        SelectObject(memdc,bk2);
        SelectObject(memdc,p2);
        Rectangle(memdc,0,45,ccp->width,ccp->currentHeight);  
        
        //paint folders
        if(ccp->consonante && ccp->over!=ASONANTE)
            BitBlt(memdc, 0, 30,ccp->width-1,20 , MemDC, 0, 189, SRCCOPY); 
        else if(ccp->consonante && ccp->over==ASONANTE)
            BitBlt(memdc, 0, 30,ccp->width-1,20 , MemDC, 0, 209, SRCCOPY); 
        else if(!ccp->consonante && ccp->over!=CONSONANTE)
            BitBlt(memdc, 0, 30,ccp->width-1,20 , MemDC, 0, 229, SRCCOPY); 
        else 
            BitBlt(memdc, 0, 30,ccp->width-1,20 , MemDC, 0, 249, SRCCOPY); 
            
        //paint buttons
        butspace=(ccp->width-153)/4;
        //FNV
        if(ccp->over!=FNV && ccp->forma!=FNV)
            BitBlt(memdc, butspace, 60,51,19 , MemDC, 0, 269, SRCCOPY); 
        else if(ccp->forma==FNV)
            BitBlt(memdc, butspace, 60,51,19 , MemDC, 102, 269, SRCCOPY); 
        else
            BitBlt(memdc, butspace, 60,51,19 , MemDC, 51, 269, SRCCOPY); 


        //FVP 
        if(ccp->over!=FVP && ccp->forma!=FVP)
            BitBlt(memdc, butspace*2+51, 60,51,19 , MemDC, 0, 288, SRCCOPY); 
        else if(ccp->forma==FVP)
            BitBlt(memdc,butspace*2+51, 60,51,19 , MemDC, 102, 288, SRCCOPY); 
        else
            BitBlt(memdc, butspace*2+51, 60,51,19 , MemDC, 51, 288, SRCCOPY); 

         //FVNP 
        if(ccp->over!=FVNP && ccp->forma!=FVNP)
            BitBlt(memdc, butspace*3+102, 60,51,19 , MemDC, 0, 307, SRCCOPY); 
        else if(ccp->forma==FVNP)
            BitBlt(memdc,butspace*3+102, 60,51,19 , MemDC, 102, 307, SRCCOPY); 
        else
            BitBlt(memdc, butspace*3+102, 60,51,19 , MemDC, 51, 307, SRCCOPY);                                             
    }

    //double buffering
    BitBlt(hDC, 0, 0,ccp->width,ccp->currentHeight , memdc, 0, 0, SRCCOPY); 
  
    //blablabla  
    DeleteObject(bk1);
    DeleteObject(p1); 
    DeleteObject(hf);
    DeleteObject(bk2);
    DeleteObject(p2);                 
    DeleteDC(hDC);
    //DeleteObject(hf);
    DeleteDC(MemDC);
    EndPaint(hwnd, &Ps);    
}




static void closeBut(HWND hwnd,dicButtonStruc* ccp,BOOL quick)
{
                  destroyTT(hwnd,ccp);
                  int kk;
                  ccp->width-=15;
                  if(ccp->ready)
                  ShowWindow(ccp->eURL,SW_HIDE);
                  ccp->open=FALSE;
                  openDic=NULL;
                  ccp->currentHeight=ccp->height;
                  SetWindowPos(hwnd,0,0,ccp->top,ccp->width,ccp->height,0);        
                  if(!quick)
                  {
                      for(kk=ccp->top;kk<ccp->posY;kk+=6)
                      {
                          SetWindowPos(hwnd,0,0,kk,ccp->width,ccp->height,0);
                          InvalidateRect(hwnd,NULL,FALSE);        
                          UpdateWindow(hwnd); 
                          Sleep(10);
                      }
                  }
                  SetWindowPos(hwnd,0,0,ccp->posY,ccp->width,ccp->height,0);           
}



void save(char* filename,dicButtonStruc* ccp)
{
     //open files 
     FILE *w,*r;
     char fileop[MAX_PATH];
     char c;
     int co=0;
     memset(fileop,'\0',MAX_PATH);
     w=fopen(filename,"w");
     
     if(ccp->consonante && ccp->forma==FNV)
     sprintf(fileop,"temp/%s%d%d-1-c.me",ccp->word,ccp->VoH,ccp->sil);
     else if(ccp->consonante && ccp->forma==FVP)
     sprintf(fileop,"temp/%s%d%d-2-c.me",ccp->word,ccp->VoH,ccp->sil);
     else if(ccp->consonante && ccp->forma==FVNP)
     sprintf(fileop,"temp/%s%d%d-3-c.me",ccp->word,ccp->VoH,ccp->sil); 
     else if(!ccp->consonante && ccp->forma==FNV)
     sprintf(fileop,"temp/%s%d%d-1-a.me",ccp->word,ccp->VoH,ccp->sil);
     else if(!ccp->consonante && ccp->forma==FVP)
     sprintf(fileop,"temp/%s%d%d-2-a.me",ccp->word,ccp->VoH,ccp->sil);
     else if(!ccp->consonante && ccp->forma==FVNP)
     sprintf(fileop,"temp/%s%d%d-3-a.me",ccp->word,ccp->VoH,ccp->sil); 

     r=fopen(fileop,"r");
     
     if(w!=NULL)
     {
         fputs("###########################################################\n\
#Lista generada por M&E Diccionario De Rimas\n\
###########################################################\n\n",w);
         while(!feof(r))
         {
             c=getc(r);
             if(c!='0')
             putc(c,w);
             else
             putc(' ',w);
             co++;
             if(co==40)
             fputs("Palabra original:\t ",w);
             else if(co==80)
             {
                 putc('\n',w);
                 co=0;
             }                   
         }
     }
     
     if(w!=NULL)
     fclose(w);
     if(r!=NULL)
     fclose(r);   
     
}







/******************************
*CALLBACK PROCEDURE
*******************************/

LRESULT CALLBACK dicButtonProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    dicButtonStruc *ccp = GetDicButtonStruc(hwnd);
    switch(msg)
    {
       
       //--------------------------WM_NCHITTEST------------------------------------        
       case WM_NCHITTEST:
       {
           //get coordinates
            UINT uHitTest = DefWindowProc(hwnd, WM_NCHITTEST, wParam, lParam);
            int xPos = LOWORD(lParam); 
            int yPos = HIWORD(lParam);
            int former=ccp->over;
            int butspace=(ccp->width-153)/4;
            RECT wind; 
            GetWindowRect(hwnd,&wind);
            xPos-=wind.left;
            yPos-=wind.top;
            if(xPos>ccp->width-22 && yPos<22 && xPos<ccp->width-2)
                ccp->over=DESTROY;
            else if(xPos>ccp->width-44 && yPos<22 && xPos<ccp->width-24 && ccp->open)
                ccp->over=CLOSE;
            else if(xPos>ccp->width-44 && yPos<22 && xPos<ccp->width-24)
                ccp->over=OPEN;
            else if(xPos>ccp->width-66 && yPos<22 && xPos<ccp->width-46)
                ccp->over=SAVE;
            else if(yPos>30 && yPos<50 && xPos<65)
                ccp->over=CONSONANTE;
            else if(yPos>30 && yPos<50 && xPos<128)
                ccp->over=ASONANTE;
            else if(yPos>60 && yPos<79 && xPos>butspace && xPos<butspace+51)
                ccp->over=FNV;
            else if(yPos>60 && yPos<79 && xPos>butspace*2+51 && xPos<butspace*2+102)
                ccp->over=FVP;
            else if(yPos>60 && yPos<79 && xPos>butspace*3+102 && xPos<butspace*3+153)
                ccp->over=FVNP;
            else
            { 
                ccp->over=-1; 
                ccp->pressed=-1;
            } 
                  
            //if somehing changed, paint and check mouse 
            if(former!= ccp->over)
            {
	            InvalidateRect(hwnd,NULL,FALSE);        
                UpdateWindow(hwnd);  
                TRACKMOUSEEVENT tr;
                tr.cbSize=sizeof(tr);
                tr.dwFlags=TME_LEAVE;
                tr.hwndTrack=hwnd;
                tr.dwHoverTime=HOVER_DEFAULT;
                TrackMouseEvent(&tr);                        
            }           
       return uHitTest;            
       }

 
       case ME_SEARCH_READY:
       {
           int kk=0;
           int jj=ccp->width;
           if(!ccp->open)
           jj+=15;
           ccp->eURL=CreateEURL(hwnd,10,89, jj-20,mHeight-120,"Times New Roman",16,ccp->word,ccp->sil,ccp->VoH);
           ccp->ready=TRUE;
           if(!ccp->consonante)
           kk=3;        
           setShowingEURL((ccp->forma-2)+kk ,ccp->eURL);
           if(!ccp->open)
           ShowWindow(ccp->eURL,SW_HIDE);
            
            
       }
 
 
       
       
       //---------------------------WM_LBUTTONUP-------------------------------------
       case WM_LBUTTONUP:
       {
           if(ccp->pressed==DESTROY)
           {
               eraseButton( hwnd);
               DestroyWindow(hwnd); 
               if(openDic==hwnd)
               {
                   openDic=NULL;    
               }  
               showBut();
           } 
           else if(ccp->pressed==CLOSE)
           {
               setPaintBG();
               closeBut(hwnd,ccp,FALSE); 
               showBut();   
               setPaintBG();                    
           }
           else if(ccp->pressed==OPEN)
           {
               setPaintBG(); 
               hideBut(hwnd);
               int kk;
               ccp->width+=15;
               for(kk=ccp->posY;kk>=ccp->top;kk-=5){
                   SetWindowPos(hwnd,0,0,kk,ccp->width,ccp->height,0);
                   InvalidateRect(hwnd,NULL,FALSE);        
                   UpdateWindow(hwnd);
                   Sleep(10);
               }
               ccp->open=TRUE;
               openDic=hwnd;
               SetWindowPos(hwnd,0,0,ccp->top,ccp->width,mHeight,0);
               for(kk=ccp->width;kk<mHeight;kk+=7)
               {
                   ccp->currentHeight=kk;
                   if(ccp->currentHeight>mHeight)
                      ccp->currentHeight=mHeight;
                   InvalidateRect(hwnd,NULL,FALSE);        
                   UpdateWindow(hwnd);  
                   Sleep(10);                                          
               } 
               ccp->currentHeight=mHeight;
               InvalidateRect(hwnd,NULL,FALSE);        
               UpdateWindow(hwnd);                 
               if(ccp->ready)  
               ShowWindow(ccp->eURL,SW_SHOW);  
               setPaintBG();    
               initTTBut(hwnd,ccp);             
           }
           else if(ccp->pressed==SAVE && ccp->open)
           {
                OPENFILENAME ofn;
                char szFileName[MAX_PATH]="";
     		    ZeroMemory(&ofn, sizeof(ofn));
    		    ofn.lStructSize = sizeof(ofn); 
    		    ofn.hwndOwner = hwnd;
    		    ofn.lpstrFilter = "Texto (*.txt)\0*.txt;\0Todos (*.*)\0*.*\0";
    		    ofn.lpstrFile = szFileName;
    		    ofn.nMaxFile = MAX_PATH;
    		    ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
    		    ofn.lpstrDefExt = "txt";
                if(GetSaveFileName(&ofn))
                {
                       save(szFileName,ccp);                  
                                         
                }
                
           }
           ccp->pressed=-1;
           InvalidateRect(hwnd,NULL,FALSE);        
           UpdateWindow(hwnd);          
       }    
       break;
       
       
       //---------------------------WM_MOUSELEAVE------------------------------------
       case WM_MOUSELEAVE:
           ccp->over=-1;
           ccp->pressed=-1;
           InvalidateRect(hwnd,NULL,FALSE);        
           UpdateWindow(hwnd);  
       break;
       
       
       //-----------------------------WM_LBUTTONDOWN---------------------------------- 
       case WM_LBUTTONDOWN:
       {
           int kk=0;

           ccp->pressed=ccp->over;
           if(ccp->over==CONSONANTE) 
               ccp->consonante=TRUE;
           else if(ccp->over==ASONANTE)
               ccp->consonante=FALSE;
           else if(ccp->over==FNV)
               ccp->forma=FNV;
           else if(ccp->over==FVP)
               ccp->forma=FVP;
           else if(ccp->over==FVNP)
               ccp->forma=FVNP; 
            if(!ccp->consonante)
               kk=3; 
           if(ccp->ready)         
           setShowingEURL((ccp->forma-2)+kk ,ccp->eURL);
           InvalidateRect(hwnd,NULL,FALSE);        
           UpdateWindow(hwnd);  
       }
       break;
       
       
       //------------------------------WM_NCCREATE--------------------------------- 
       case WM_NCCREATE:
       break;
       
       
       //------------------------------WM_ERASEBKGND---------------------------------
       case WM_ERASEBKGND:
       return 1;
       
       //-----------------------------WM_NCDESTROT-----------------------------------
       case WM_NCDESTROY:
           if(ccp->ready)
           DestroyWindow(ccp->eURL);
           free(ccp);
       break;
       
       //-----------------------------WM_PAINT----------------------------------------
       case WM_PAINT:
           paintDicButton(hwnd,ccp);
       break;
       
       
       //blabla
        default:
        break;
    }

    return DefWindowProc(hwnd, msg, wParam, lParam);
}







/////////////////////////////////////////////////////////////////////////////////////
/***********************************METHODS ("PUBLIC")******************************/
//////////////////////////////////////////////////////////////////////////////////////
/**********************
*Register the class
*
***********************/


void InitDicButton(HWND parent)
{
 
    WNDCLASSEX wc;

    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = dicButtonProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = sizeof( dicButtonStruc * );
    wc.hInstance     = GetModuleHandle(0);
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_dicButtonName;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

    RegisterClassEx(&wc);
}


/**********************
*Craete a button
*
***********************/


HWND CreateDicButton(HWND parent,int w,int h,int posX,int posY,char* name,int maxHeight,int top,int sil,int VoH)
{


   HWND thisone=CreateWindowEx(0,g_dicButtonName, "",WS_VISIBLE|WS_CHILD|WS_CLIPCHILDREN,
             posX, top, w, maxHeight,parent, NULL, GetModuleHandle(0), NULL); 
   if(openDic!=NULL)
   {
       closeBut(openDic,GetDicButtonStruc(openDic),TRUE); 
       openDic=NULL;
   }
   hideBut(NULL); 
   dicButtonStruc *ccp = GetDicButtonStruc(thisone);
   ccp = malloc( sizeof(dicButtonStruc) );
   if(ccp == NULL){ return NULL;}

    // Initialize the CustCtrl structure. 
    ccp->hwnd=parent;
    ccp->posX=posX;
    ccp->posY=posY;
    ccp->width=w;
    ccp->height=h;
    ccp->top=top;
    ccp->VoH=VoH;
    ccp->sil=sil;
    ccp->open=TRUE;
    ccp->consonante=TRUE;
    ccp->forma=FNV;
    ccp->currentHeight=maxHeight;
    ccp->over=-1;
    ccp->pressed=-1;
    ccp->word=name;
    ccp->ready=FALSE;
    mHeight=maxHeight;
    
    
    SetDicButtonStruc(thisone, ccp);  	       
    openDic=thisone;
    initTTBut(thisone,ccp);
    return thisone;     
}



void setMaxHeight(int y,HWND hwnd)
{
    mHeight=y;
    if(hwnd!=NULL)
    {
        dicButtonStruc *ccp = GetDicButtonStruc(hwnd);
        ccp->currentHeight=y;
        if(openDic==hwnd)
        SetWindowPos(hwnd,0,0,ccp->top,ccp->width,y,0);
        if(ccp->ready)
        setHeight(ccp->eURL,y-120);                               
        InvalidateRect(hwnd,NULL,FALSE);        
        UpdateWindow(hwnd);                               
    }    
}

void moveUp(HWND hwnd,int y)
{
      dicButtonStruc *ccp = GetDicButtonStruc(hwnd); 
      ccp->posY-=y;      
      SetWindowPos(hwnd,0,0,ccp->posY,ccp->width,ccp->height,0);   
}


void scrollB(HWND hwnd,int y)
{
   if(hwnd!=NULL)
   {  
      dicButtonStruc *ccp = GetDicButtonStruc(hwnd); 
      ccp->posY=y;      
      SetWindowPos(hwnd,0,0,ccp->posY,ccp->width,ccp->height,0); 
      InvalidateRect(hwnd,NULL,FALSE);        
      UpdateWindow(hwnd);                               
   }  
}

void DestroyBut(HWND hwnd)
{
      dicButtonStruc *ccp = GetDicButtonStruc(hwnd);
      if(ccp->ready) 
      DestroyFiles(ccp->eURL);     
     
}



