/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/


/***********************************************************
*buttonManager.c
*(C) Eduardo Rodriguez 2005
*
*PORPUSE:this functions (all of them public) provide an interface between
*        the buttons and the diccionary, affectively making the buttons 
*        behave as a group
*HISTORY: 2/11/2005 created
***********************************************************/
#include <windows.h>
#include "buttonManager.h"
#include "MEDicBut.h"

/****************************
*DATA MEMBERS
*****************************/



//struc for the linked list
typedef struct _DICBUT
{
    char word[200];        //word that this button helds
    HWND point;            //handle to this button
    int prev;              //index of previous button
    int next;              //index of next button
}DICBUT;


static int currentEmpty=0;       //current empty spot in the linked list
static int lastDone=-1;          //last button done
static int beggining=0;          //first element in the linked list
static DICBUT dicarray[1000];    //array holding the list
static int howmanybut=0;         //how many buttons we've got
static HWND thisdiccio=NULL;     //handle to the dic
static HWND thescrl=NULL;        //handle to the dic's scrollbar
static int dicwid,dichei;        //width & height of the dic
static int index=0;              //firts button showing in the dic
static BOOL paintbg=FALSE;

extern HWND openDic;             //from MEDicBut.c, is there an open button, and if so, what's the handle



/***********************
*METHODS
************************/

/************
//initialize
************/
void InitButManager(HWND dic,HWND scroll,int w,int h)
{
    int kk;
    thisdiccio=dic;
    thescrl=scroll;
    dicwid=w;
    dichei=h;
    
    //initialize all members of the array
    for(kk=0;kk<1000;kk++)
    {
        dicarray[kk].point=NULL; 
        dicarray[kk].prev=-1;
        dicarray[kk].next=-1;              
    }          
}






/*********************
//add a new button
*********************/
HWND newButt(char* word,int sil,int VoH)
{
    int kk;
    HWND res=NULL;
    
    //if the list is full...
    if(currentEmpty==1333)
        MessageBox(NULL, "No puedes tener ms de 1000 bsquedas a un tiempo.\r\nPara realizar una bsqueda nueva, cierra alguna de las ventanas.", "Error",MB_OK | MB_ICONINFORMATION); 

    //else
    else
    {
        //init the char array holding the word
        for(kk=0;kk<200;kk++)
            dicarray[currentEmpty].word[kk]=word[kk];
            
        //create the button and keep handle
        res=dicarray[currentEmpty].point=CreateDicButton(thisdiccio,dicwid,24,0,47+24*howmanybut, dicarray[currentEmpty].word,dichei,47,sil,VoH);  
 
        //if it's not the first...
        if(lastDone!=-1)
            dicarray[lastDone].next=currentEmpty;
            
            
        dicarray[currentEmpty].prev=lastDone;
        lastDone=currentEmpty;
        dicarray[currentEmpty].next=-1;
        
        howmanybut++;
        
        //scrollbar
        setdoclengthMEScroll(thescrl, 1);
        
        //look for next empty spot
        currentEmpty=1333;
        for(kk=0;kk<1000;kk++)
        {
            if(dicarray[kk].point==NULL)
            {
                currentEmpty=kk;
                kk=2000;                            
            }                                                
        }
        
        //if this is the last one...
        if(currentEmpty==1333)
            MessageBox(NULL, "Esta es la ltima bsqueda permisible,\r\n porque no puedes tener ms de 1000 ventanas abiertas a un tiempo. \r\nCierra alguna ventana antes de realizar una bsqueda nueva", "Error",MB_OK | MB_ICONINFORMATION); 
    }
    return res;   
}


void setPaintBG()
{
   if(!paintbg)  
    paintbg=TRUE;
   else
    paintbg=FALSE;     
     
}



/*********************
//erase a button
*********************/
void eraseButton(HWND hwnd)
{
    int kk,tt,jj;
    //look for it
    for(kk=0;kk<1000;kk++)
    {
        if(dicarray[kk].point==hwnd)
        {
            //found it
            currentEmpty=kk;
            dicarray[kk].point=NULL;
            
            //if it's the first element
            if(dicarray[kk].prev==-1)
            {
                // if the array is empty
                if(dicarray[kk].next==-1)
                {
                    lastDone=-1;
                    beggining=0;   
                    currentEmpty=0; 
                }
                else
                {
                    beggining=dicarray[kk].next;
                    dicarray[dicarray[kk].next].prev=-1;    
                }               
            }
            
            //if it's the last element
            else if(dicarray[kk].next==-1)
            {
                lastDone=dicarray[kk].prev;
                dicarray[dicarray[kk].prev].next=-1;    
            }
            
            //if it's neither
            else
            {
                dicarray[dicarray[kk].prev].next=dicarray[kk].next;   
                dicarray[dicarray[kk].next].prev=dicarray[kk].prev;
            }
            
            //animate reposition
            if(dicarray[kk].next>0 && dicarray[kk].next<1000)
            {
 
                for(jj=0;jj<24;jj++)
                {
                    tt=dicarray[kk].next;
                    while(dicarray[tt].point!=NULL)
                    {
                        moveUp(dicarray[tt].point,1) ;  
                        tt=dicarray[tt].next;                            
                    }                                   
                }              
            }
            
            //initialize new empty spot
            dicarray[kk].prev=-1;
            dicarray[kk].next=-1;
            kk=3000;
            howmanybut--;
            
            
            setdoclengthMEScroll(thescrl, howmanybut);
        }                      
    }
}





/*********************
*Hide all buts excep the
*one whose handle I give you
*********************/
void hideBut(HWND hwnd)
{
    int kk=beggining;
    while(dicarray[kk].point!=NULL)
    {
        if(dicarray[kk].point!=hwnd)
            ShowWindow(dicarray[kk].point,SW_HIDE);      
        kk=dicarray[kk].next;
    } 
    setdoclengthMEScroll(thescrl, 1);  
     
         
}






void scrollButton(int y,BOOL show)
{

    int kk=beggining,jj=0,ll=47;
    index=y;
    while(dicarray[kk].point!=NULL)
    {
        if(jj<y)
           ShowWindow(dicarray[kk].point,SW_HIDE);
        else 
        {
            scrollB(dicarray[kk].point,ll);
            if(show)
            ShowWindow(dicarray[kk].point,SW_SHOW);
            ll+=24;
        }     
        kk=dicarray[kk].next;
        jj++;
    } 

}

/********************
*Show them all
*(if they are visible)
********************/
void showBut()
{

    int kk=beggining;
    int jj=index;
    int ll=0;
    while(dicarray[kk].point!=NULL)
    {
        if(ll>=jj)
        ShowWindow(dicarray[kk].point,SW_SHOW);      
        kk=dicarray[kk].next;
        ll++;
    }          
    setdoclengthMEScroll(thescrl, howmanybut);    
    if(howmanybut-index<dichei/24)
    {
        int kk=howmanybut-dichei/24;
        if(kk<0)kk=0;
        scrollButton(kk,TRUE); 
        setposMEScroll(thescrl,kk);       
    }       
  
}







BOOL isOpen()
{
    return paintbg; 
}


void eraseEverything()
{
    int kk=beggining;
    while(dicarray[kk].point!=NULL)
    {
        DestroyBut(dicarray[kk].point);  
        kk=dicarray[kk].next;
    }               
     
}

void newSize(int w,int h)
{
    int kk=beggining;
    while(dicarray[kk].point!=NULL)
    {
        setMaxHeight(h-47,dicarray[kk].point);      
        kk=dicarray[kk].next;
    }          
    dicwid=w;     
    dichei=h-47;
    if(howmanybut-index<dichei/24)
    { 

        if(openDic==NULL)
        {
            int kk=howmanybut-dichei/24;
            if(kk<0)kk=0;
            scrollButton(kk,TRUE); 
            setposMEScroll(thescrl,kk);
        }
    }
}


