/*************************************************************************
*GLOBAL TO ALL CONTROLS
*************************************************************************/
void initializeMEControls(HWND parent);


/**********************************************************************
*MEMOUSEHOOK
**********************************************************************/
//global hook that sends the mouse position to all registered windows
//every 200 miliseconds

            //init, done by global     
void me_hook_beginWatching(HWND hwnd);
            //registered, and recieved an ME_MOUSEPOS for free!
BOOL registerMEHook(HWND hwnd);

#define ME_MOUSEPOS  0x8201 //lParam=x wParam=y

/******************************************************************************************
*LIST
******************************************************************************************/
//initialize the list class, should be called by global
void InitMEList(HWND parent);//handle to any valid window
//create a list
HWND CreateMEList(HWND parent,                 //parent
                   int posX,
                   int posY, 
                   int w,
                   int h, 
                   char* strings,               //comma separated list to write
                   char* fontName,
                   int fontSize,
                   int index,                  //first Item on the list
                   int elements,               //number of initial elements in list
                   BOOL selfdestroy);          //should the window selfdestroy when it losses focus?

//messages. wParam carries the number of the element selected
#define ME_LIST_SELECTED  0x8006 

/****************************************************************************
*SCROLLBARS
****************************************************************************/
//initialize the scrollbar class
void InitMEScroll(HWND parent);//handle to any window
//create a scrollbar
HWND CreateMEScroll(HWND parent,      //handle to parent window  
                  int posX,           //position x
                  int posY,           //position y
                  int w,              //width
                  int h,              //height
                  unsigned int docLen,//document length in document units
                  unsigned int docPos,//position of first visible line in doc units
                  int screenSize,     //visible part of the document in document units
                  BOOL vertical);     //TRUE for a vertical scrollbar, FALSE for horizo.
				  
//resize
void resizeMEScroll(HWND hwnd,		  //handle to scrollbar to be modified
					int x,			  //width
					int y);           //height
					
//set the size of the visible part of the document
void setscreensizeMESCroll(HWND hwnd, //handle to scrollbar to be modified
							int size);//size of visible part in document units
							
//set the Length of the document							
void setdoclengthMEScroll(HWND hwnd,          //handle to scrollbar to be modified
						  unsigned int size); //new size of the document in document units
						
//set the position we are in. Should be the number of the first visible line in doument units
void setposMEScroll(HWND hwnd,      //handle to scrollbar to be modified
						  int pos); //new position we are in, in document units

						  
//messages. wParam contains new position in document units
#define ME_SCROLL_VERTICAL  0x8001
#define ME_SCROLL_HORIZONTAL 0x8002

/*****************************************************************************************
*COMBO BOX
************************************************************************************/

//----------------------------------------------methods
void InitMEComboBox(HWND parent);
int GetSelectedMEComboBox(HWND hwnd);
HWND CreateMEComboBox(HWND parent,
                      int posX,
                      int posY, 
                      int w,
                      int h,
                      int dropWidth,
                      int dropHeight,
                      int wb,         //width of the button
                      char* strings, //comma separated list 
                      char* fontName,
                      int fontSize,
                      int elements);//handle to bitmap to paint the button and background. If NULL, custom
                                      //must be vertical. 1-button, 2-button over, 3-button pressed, 4-bg
                                      //button must be specified width and height-4


/*******************************************************************************
*METOOLTIPS
*******************************************************************************/
void InitMEToolTip(HWND parent);
HWND CreateMEToolTip(HWND parent,int left,int top, char* string);



void InitToolTipManager(HWND parent);
int addToolTip(HWND window,int x,int y,int w,int h,char* message);
void destroyToolTip(int id);
void setWorking(BOOL work);
void activateTT(int id);
void desactivateTT(int id);
void createTTTimer(HWND hwnd,int id);
#define ME_TT_TIMESUP 0x8331

