/* ***********************************************************************************************
*metooltipmanager.c													
*(c)Eduardo Rodriguez 2005																
*																					
*porpuse:   
*history:	18/11/2005 created															
*********************************************************************************************** */


#include <windows.h>
#include <string.h>
#include "MEControls.h"

#define FULL 1333

//struc for the linked list
typedef struct _Mett
{
    char *word;        //message that this tooltip holds
    HWND target;       //window that activates the tooltip
    int x,y,w,h;       //rect that activates the tooltip
    BOOL active;       //should this show a tooltip
    HWND htip;             //handle to tooltip         
    int prev;              //index of previous tooltip
    int next;              //index of next tooltip
}METT;

const char g_METoolTipsMang[]="metooltipsmang";

static METT mettarray[1000];
static int showing=-1;         //handle to the tooltip that's showing, if any
static int howmany=0;             //how many tooltips registered
static HHOOK g_MEhMouseHook = NULL;
static BOOL buttondown=FALSE;
static beggining=0;
static HWND tipbelongs=NULL; //who does shoing tooltip belong to?
static int currentEmpty=0;
static int lastDone=-1;
static int working=TRUE;
static HWND thismang=NULL;





LRESULT CALLBACK MEMouseHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
        
    int kk,jj=beggining;
    BOOL success=FALSE;
    BOOL therewasone=FALSE;
    
  	if(nCode < 0)
		return CallNextHookEx(g_MEhMouseHook, nCode, wParam, lParam);
if(working)
{
 	MOUSEHOOKSTRUCT * pMouseInfo = (MOUSEHOOKSTRUCT*)lParam; 
     
     //clicks? hide them!!!

   if (wParam == WM_LBUTTONDBLCLK || wParam==WM_LBUTTONDOWN || wParam==WM_LBUTTONUP||
		wParam == WM_MBUTTONDBLCLK || wParam == WM_MBUTTONDOWN || wParam == WM_MBUTTONUP ||
		wParam == WM_RBUTTONDBLCLK || wParam == WM_RBUTTONDOWN || wParam == WM_RBUTTONUP)
   {
//      if(showing!=NULL)
//      {
//          DestroyWindow(showing);
//          showing=NULL;
//          tipbelongs=NULL;                                        
//      }
//      if(wParam==WM_LBUTTONDOWN)
//          buttondown=TRUE;
//      else if(wParam==WM_LBUTTONUP)
//          buttondown=FALSE;

   }
   else
   {  
       while(jj>=0 && mettarray[jj].target!=NULL)
       {  
           if(pMouseInfo->hwnd==mettarray[jj].target)
           { 
               RECT wind;
               GetWindowRect(mettarray[jj].target,&wind);

               if(wind.left+mettarray[jj].x<pMouseInfo->pt.x &&  wind.left+mettarray[jj].x+mettarray[jj].w>pMouseInfo->pt.x && wind.top+mettarray[jj].y<pMouseInfo->pt.y &&  wind.top+mettarray[jj].y+mettarray[jj].h>pMouseInfo->pt.y)
               {
                   success=TRUE;
                   if(showing!=-1 && mettarray[jj].active && showing!=jj)
                   {
                       DestroyWindow(mettarray[showing].htip);
                       mettarray[showing].htip=NULL;
                       showing=-1;
                       tipbelongs=NULL;   
                       therewasone=TRUE;              
                   }
                   if(showing!=jj && !buttondown && mettarray[jj].active)
                   { 
//                       if(therewasone)
//                       {
//                           mettarray[jj].htip=CreateMEToolTip(mettarray[jj].target,pMouseInfo->pt.x+5,wind.top+mettarray[jj].y+mettarray[jj].h+5, mettarray[jj].word);   
//                           showing=jj;
//                           tipbelongs=mettarray[jj].target;
//                       }
//                       else
//                       {
                           createTTTimer(thismang,jj);
                       //}
                   }
               
                                                             
               }                                    
                                                     
           }        
                            
           jj=mettarray[jj].next;              
       }
       if(!success && showing!=-1)
       {
           DestroyWindow(mettarray[showing].htip);
           mettarray[showing].htip=NULL;
           showing=-1;
           tipbelongs=NULL;                        
       }

   }
} 
   return CallNextHookEx(g_MEhMouseHook, nCode, wParam, lParam);
}


LRESULT CALLBACK metooltipmangproc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{


    switch(msg)
    {
     
         case ME_TT_TIMESUP:
         {     
             if(wParam!=showing && mettarray[wParam].target!=NULL)
             {
                 POINT ps;
                 RECT wind;
                 GetWindowRect(mettarray[wParam].target,&wind);
                 GetCursorPos(&ps);
                 if(wind.left+mettarray[wParam].x<ps.x &&  wind.left+mettarray[wParam].x+mettarray[wParam].w>ps.x && wind.top+mettarray[wParam].y<ps.y &&  wind.top+mettarray[wParam].y+mettarray[wParam].h>ps.y)
                 {
                       mettarray[wParam].htip=CreateMEToolTip(mettarray[wParam].target,ps.x+5,wind.top+mettarray[wParam].y+mettarray[wParam].h+5, mettarray[wParam].word);   
                       showing=wParam;
                       tipbelongs=mettarray[wParam].target;                                     
                 }
                 
                                         
                                
             }
         
         
              
         }    
         break;
         
         //blabla    
         default:
         break;
    }

    return DefWindowProc(hwnd, msg, wParam, lParam);
}






void InitToolTipManager(HWND parent)
{
     
    WNDCLASSEX wc;

    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         =  0;
    wc.lpfnWndProc   = metooltipmangproc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = GetModuleHandle(0);
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_METoolTipsMang;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

    RegisterClassEx(&wc);      
     
     thismang=CreateWindowEx(0,g_METoolTipsMang, "",WS_POPUP,0, 0, 0, 0,
       parent, NULL, GetModuleHandle(0), NULL);       
     

    int kk;
    for(kk=0;kk<1000;kk++)
    {
         mettarray[kk].prev=-1;
         mettarray[kk].next=-1;
         mettarray[kk].htip=NULL;
         mettarray[kk].target=NULL;                     
    }
    
  	g_MEhMouseHook =SetWindowsHookEx(WH_MOUSE, MEMouseHookProc, NULL, GetCurrentThreadId());

}

int addToolTip(HWND window,int x,int y,int w,int h,char* message)
{
    int returnVal=-1,kk;
    
    if(currentEmpty!=FULL)
    {  
//        if(message[0]=='C')
//        {
//          char temp[1000];
//          sprintf(temp,"id=%d   beginning=%d",currentEmpty,beggining);
//                         MessageBox(NULL, temp, "Error",MB_OK | MB_ICONINFORMATION); 
//        }
        returnVal=currentEmpty;
        mettarray[currentEmpty].word=malloc(sizeof(char)*(strlen(message)+1));
        mettarray[currentEmpty].word[0]='\0';
        strcat(mettarray[currentEmpty].word,message); 
        mettarray[currentEmpty].x=x;
        mettarray[currentEmpty].y=y;
        mettarray[currentEmpty].w=w;
        mettarray[currentEmpty].h=h;
        mettarray[currentEmpty].target=window;
        mettarray[currentEmpty].active=TRUE;  
        mettarray[currentEmpty].htip=NULL; 
        mettarray[currentEmpty].prev=lastDone;
        
        if(lastDone!=-1)
            mettarray[lastDone].next=currentEmpty;
            
        lastDone=currentEmpty;
        
        howmany++; 
        
        //look for next empty spot
        currentEmpty=FULL;
        for(kk=0;kk<1000;kk++)
        {
            if(mettarray[kk].target==NULL)
            {
                currentEmpty=kk;
                kk=1111;                              
            }                      
        }    
                          
                          
                          
    }
    else
                MessageBox(NULL, "Error TT0. Por favor, enva un mensaje \r\n\
                                  a www.mollyandedu.com especificando este error \r\n\
                                  y explicando las circumstancias en las que \r\n\
                                  ha surgido. Gracias.", "Error",MB_OK | MB_ICONINFORMATION); 

    
    return returnVal;
}


void destroyToolTip(int id)
{
 
  if(id!=-1)
  {
    currentEmpty=id;
    if(showing!=-1 && mettarray[id].htip==mettarray[showing].htip)
    {
        DestroyWindow(mettarray[showing].htip); 
        mettarray[showing].htip=NULL; 
        tipbelongs=NULL;
        showing=-1;
    } 

    free(mettarray[id].word); 
    mettarray[id].target=NULL;
    howmany--;
    //if it's first element
    if(mettarray[id].prev==-1)
    {
        //if array is empty
        if(howmany==0)
        {
            lastDone=-1;
            beggining=0;                         
        }
        else
        {
            beggining=mettarray[id].next;
            mettarray[mettarray[id].next].prev=-1;        
        }
    }   
    //if its the last element
    else if(mettarray[id].next==-1)
    {
        lastDone=mettarray[id].prev;
        mettarray[mettarray[id].prev].next=-1;            
    }
    else
    {
        mettarray[mettarray[id].prev].next=mettarray[id].next;
        mettarray[mettarray[id].next].prev=mettarray[id].prev; 
        
    }
    mettarray[id].prev=-1;
    mettarray[id].next=-1;
  }  
}

void setWorking(BOOL work)
{
    working=work;     
}

void activateTT(int id)
{
   mettarray[id].active=TRUE;     
}

void desactivateTT(int id)
{
   mettarray[id].active=FALSE;     
}

