/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/


/* ***********************************************************************************************
*dicButton.c													
*(c)Eduardo Rodriguez 2005																
*																					
*porpuse:   This creates the buttons that emerge as new rimes are added. The have to fundamental
*           states, closed and open. 
*          
*history:	21/09/2005 created															
*********************************************************************************************** */


#include <windows.h>
#include "dicB.h"
#include "controles/MEControls.h"

//info for every instance
typedef struct _dicButtonStruc
{
    int posX;
    int posY;
    int prevY;
    int over;
    int mousedown;
    int currentHeight;
    int reading;
    int maxHeight;
    BOOL consonant; //one of the states  defined in constants       
    BOOL open;
    HWND     hwnd;
    char* word;   
    HBITMAP bitmap;     
}dicButtonStruc;



/*************************
*DATA MEMBERS
**************************/
const char g_dicButtonName[]="dicButton";

extern HBITMAP bm;
extern HDC memdc;
HWND top=NULL;
/*************************
*METHODS ("PRIVATE")
*************************/

dicButtonStruc*  GetDicButtonStruc(HWND hwnd)
{
    return (dicButtonStruc *)GetWindowLong(hwnd, 0);
}

void SetDicButtonStruc(HWND hwnd, dicButtonStruc *ccp)
{
    SetWindowLong(hwnd, 0, (LONG)ccp);
}




//paints the default

void paintDicButton(HWND hwnd,dicButtonStruc* ccp)
{

     
                 PAINTSTRUCT Ps;
               HDC hDC = BeginPaint(hwnd, &Ps);
               HDC MemDC= CreateCompatibleDC(hDC);
               SelectObject(MemDC,bm);



               //paint background
               if(!ccp->open)
                 BitBlt(memdc, 0,  0 ,198 ,24, MemDC, 131,28 , SRCCOPY); 
               else
               {
                 int kk;
                 BitBlt(memdc, 0,  0 ,198 ,80, MemDC, 91,71 , SRCCOPY);   
                 for(kk=80;kk<ccp->currentHeight;kk+=5)
                 BitBlt(memdc, 0,  kk ,198 ,5, MemDC, 91,97 , SRCCOPY);
                 BitBlt(memdc, 0,  ccp->currentHeight-1 ,198 ,1, MemDC, 131,51 , SRCCOPY); 
                   
               }
               
               
               //write word
               RECT rec;
               rec.top=3;
               rec.bottom=22;
               rec.left=5;
               rec.right=130;
               DrawText(memdc,ccp->word,strlen(ccp->word),&rec,DT_END_ELLIPSIS);  
               
               
               //paint buttons on the top
                  //close
               if(ccp->over!=DESTROY && ccp->mousedown!=DESTROY)
                 BitBlt(memdc, 176,  2 ,20 ,20, MemDC, 0,266 , SRCCOPY); 
               if(ccp->over==DESTROY)
                 BitBlt(memdc, 176,  2 ,20 ,20, MemDC, 20,266 , SRCCOPY); 
               if(ccp->mousedown==DESTROY)
                 BitBlt(memdc, 176,  2 ,20 ,20, MemDC, 40,266 , SRCCOPY); 
                 //open
               if(!ccp->open)
               {
                  if(ccp->over!=OPEN && ccp->mousedown!=OPEN)
                      BitBlt(memdc, 155,  2 ,20 ,20, MemDC, 0,246 , SRCCOPY);
                  if(ccp->over==OPEN)
                      BitBlt(memdc, 155,  2 ,20 ,20, MemDC, 20,246 , SRCCOPY);             
                  if(ccp->mousedown==OPEN)
                      BitBlt(memdc, 155,  2 ,20 ,20, MemDC, 40,246 , SRCCOPY);            
               }  
               else
               {
                   if(ccp->over!=CLOSE && ccp->mousedown!=CLOSE)
                      BitBlt(memdc, 155,  2 ,20 ,20, MemDC, 0,226 , SRCCOPY);
                  if(ccp->over==CLOSE)
                      BitBlt(memdc, 155,  2 ,20 ,20, MemDC, 20,226 , SRCCOPY);             
                  if(ccp->mousedown==CLOSE)
                      BitBlt(memdc, 155,  2 ,20 ,20, MemDC, 40,226 , SRCCOPY);              
               }
                 //save
               if(ccp->over!=SAVE && ccp->mousedown!=SAVE)
                      BitBlt(memdc, 134,  2 ,20 ,20, MemDC, 0,286 , SRCCOPY);  
               if(ccp->over==SAVE)
                      BitBlt(memdc, 134,  2 ,20 ,20, MemDC, 20,286 , SRCCOPY); 
               if(ccp->mousedown==SAVE)
                      BitBlt(memdc, 134,  2 ,20 ,20, MemDC, 40,286 , SRCCOPY);         


               //paint folders
               if(ccp->open)
               {
                  if(ccp->consonant && ccp->over!=ASONANTE)
                     BitBlt(memdc, 0,  29 ,198 ,17, MemDC, 0,357 , SRCCOPY);          
                  else if(ccp->consonant)
                     BitBlt(memdc, 0,  29 ,198 ,17, MemDC, 0,323 , SRCCOPY);         
                  else if(!ccp->consonant && ccp->over!=CONSONANTE)
                     BitBlt(memdc, 0,  29 ,198 ,17, MemDC, 0,340 , SRCCOPY);  
                  else
                     BitBlt(memdc, 0,  29 ,198 ,17, MemDC, 0,306 , SRCCOPY);                         
               


               //second bunch of folders
                        //FNV
                  if(ccp->reading!=FNV && ccp->over!=FNV)
                    BitBlt(memdc, 16,  60 ,44 ,13, MemDC, 0,374 , SRCCOPY);
                  if(ccp->over==FNV)
                    BitBlt(memdc, 16,  60 ,44 ,13, MemDC, 0,400 , SRCCOPY);
                  if(ccp->reading==FNV)
                    BitBlt(memdc, 16,  60 ,44 ,13, MemDC, 0,387 , SRCCOPY);
                       //fVP
                   if(ccp->reading!=FVP && ccp->over!=FVP)
                    BitBlt(memdc, 77,  60 ,44 ,13, MemDC, 90,374 , SRCCOPY);
                  if(ccp->over==FVP)
                    BitBlt(memdc, 77,  60 ,44 ,13, MemDC, 90,400 , SRCCOPY);
                  if(ccp->reading==FVP)
                    BitBlt(memdc, 77,  60 ,44 ,13, MemDC, 90,387 , SRCCOPY);
                        //fVNP
                   if(ccp->reading!=FVNP && ccp->over!=FVNP)
                    BitBlt(memdc, 138,  60 ,44 ,13, MemDC, 45,374 , SRCCOPY);
                  if(ccp->over==FVNP)
                    BitBlt(memdc, 138,  60 ,44 ,13, MemDC, 45,400 , SRCCOPY);
                  if(ccp->reading==FVNP)
                    BitBlt(memdc, 138,  60 ,44 ,13, MemDC, 45,387 , SRCCOPY);
                  
               }
               BitBlt(hDC, 0,  0 ,198 ,ccp->currentHeight, memdc, 0,0, SRCCOPY); 
               DeleteDC(MemDC);
               EndPaint(hwnd, &Ps);  
               





}
















/******************************
*CALLBACK PROCEDURE
*******************************/

LRESULT CALLBACK dicButtonProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    dicButtonStruc *ccp = GetDicButtonStruc(hwnd);
    switch(msg)
    {
               
       case WM_NCHITTEST:
            {
             UINT uHitTest = DefWindowProc(hwnd, WM_NCHITTEST, wParam, lParam);
                 int xPos = LOWORD(lParam); 
                 int yPos = HIWORD(lParam);
                 RECT wind; 
                 GetWindowRect(hwnd,&wind);
                 xPos-=wind.left;
                 yPos-=wind.top;
             if( uHitTest==HTCLIENT)
             { 
               int former=ccp->over;
               if(xPos>134 && xPos<154 && yPos<23){
               ccp->over=SAVE;
               // showToolTip(hwnd,xPos+wind.left+10,yPos+wind.top+10,"Haz click aqu para guardar esta bsqueda en el disco duro.");
               }
               else if(xPos>155 && xPos<175 && yPos<23 && !ccp->open)
               {
               ccp->over=OPEN;
               //showToolTip(hwnd,xPos+wind.left+10,yPos+wind.top+10,"Expande el botn para mostrar los resultados");               
               }
               else if(xPos>155 && xPos<175 && yPos<23 && ccp->open)
               {
               ccp->over=CLOSE;
              // showToolTip(hwnd,xPos+wind.left+10,yPos+wind.top+10,"Miniminiza el botn y permite ver otras bsquedas");
               }
               else if(xPos>176 && yPos<23)
               {
               ccp->over=DESTROY;
               //showToolTip(hwnd,xPos+wind.left+10,yPos+wind.top+10,"Elimina esta bsqueda de la bandeja");
               }
               else if(xPos<68 && yPos>29 && yPos<46)
               {
               ccp->over=CONSONANTE;
              // showToolTip(hwnd,xPos+wind.left+10,yPos+wind.top+10,"Muestra las rimas consonantes");
               }
               else if(xPos>69 && xPos<113 && yPos>29 && yPos<46)
               {
               ccp->over=ASONANTE;
              // showToolTip(hwnd,xPos+wind.left+10,yPos+wind.top+10,"Muestra las rimas asonantes");
               }
               else if(xPos>16 && xPos<58 && yPos>60 && yPos<72)
               {
               ccp->over=FNV;
               //showToolTip(hwnd,xPos+wind.left+10,yPos+wind.top+10,"Muestra resultados que no contengan verbos");
               }
               else if(xPos>76 && xPos<120 && yPos>60 && yPos<72)
               {
               ccp->over=FVP;
               //showToolTip(hwnd,xPos+wind.left+10,yPos+wind.top+10,"Muestra formas verbales personales");
               }
               else if(xPos>138 && xPos<181 && yPos>60 && yPos<72)
               {
               ccp->over=FVNP;
               //showToolTip(hwnd,xPos+wind.left+10,yPos+wind.top+10,"Muestra formas verbales impersonales:\ngerundios, participios y formas enclticas");
               }
               else
               {
               ccp->over=-1;
               //hideToolTip(hwnd);
               }
               if(ccp->over!=former)
               {

        	      InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);  
                                         
               }
                           TRACKMOUSEEVENT tr;
                          tr.cbSize=sizeof(tr);
                          tr.dwFlags=TME_LEAVE;
                          tr.hwndTrack=hwnd;
                          tr.dwHoverTime=HOVER_DEFAULT;
                          TrackMouseEvent(&tr);              
            
                return uHitTest;  
             }
             else
              return uHitTest;
             }                   
             break; 
       case WM_LBUTTONUP:
            {//hideToolTip(hwnd);
             int xPos = LOWORD(lParam); 
             int yPos = HIWORD(lParam);
               if(xPos>134 && xPos<154 && yPos<23 && ccp->mousedown==SAVE)
               {
               
               
               }
               else if(xPos>155 && xPos<175 && yPos<23 && !ccp->open && ccp->mousedown==OPEN)
               {
                    int kk;
                    ccp->prevY=ccp->posY;
                    for(kk=ccp->posY;kk>=47;kk-=5){
                      SetWindowPos(hwnd,0,0,kk,198,24,0);
                      InvalidateRect(hwnd,NULL,FALSE);        
                      UpdateWindow(hwnd);
                      Sleep(10);
                    }
                    ccp->posY=0;
                    ccp->open=TRUE;
                     SetWindowPos(hwnd,0,0,47,198,ccp->maxHeight,0);
                    for(kk=24;kk<ccp->maxHeight;kk+=7)
                    {
                      ccp->currentHeight=kk;
                      if(ccp->currentHeight>ccp->maxHeight)
                      ccp->currentHeight=ccp->maxHeight;
                      InvalidateRect(hwnd,NULL,FALSE);        
                      UpdateWindow(hwnd);  
                      Sleep(10);                                          
                    }
               }
               else if(xPos>155 && xPos<175 && yPos<23 && ccp->open && ccp->mousedown==CLOSE)
               {
                  int kk;
                  ccp->open=FALSE;
                  ccp->currentHeight=24;
                  SetWindowPos(hwnd,0,0,0,198,24,0);
                  for(kk=0;kk<ccp->prevY;kk+=6){
                  SetWindowPos(hwnd,0,0,kk,198,24,0);
                  InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd); 
                  Sleep(10);
                  }
                  ccp->posY=ccp->prevY;
                  SetWindowPos(hwnd,0,0,ccp->posY,198,24,0);
                  
               }
               else if(xPos>176 && yPos<23 && ccp->mousedown==DESTROY)
               {
                     DestroyWindow(hwnd);
              }
               else if(xPos<68 && yPos>29 && yPos<46 && ccp->mousedown==CONSONANTE)
               {
                   if(!ccp->consonant)
                   {
                     ccp->consonant=TRUE;                   
                   }
                     
               }
               else if(xPos>69 && xPos<113 && yPos>29 && yPos<46 && ccp->mousedown==ASONANTE)
               {
                    if(ccp->consonant)
                    {
                      ccp->consonant=FALSE;                  
                    }       
               }
               else if(xPos>16 && xPos<58 && yPos>60 && yPos<72 && ccp->mousedown==FNV)
               {
                    ccp->reading=FNV;
               }
               else if(xPos>76 && xPos<120 && yPos>60 && yPos<72 && ccp->mousedown==FVP)
               {
                    ccp->reading=FVP;
               }
               else if(xPos>138 && xPos<181 && yPos>60 && yPos<72 && ccp->mousedown==FVNP)
               {
                    ccp->reading=FVNP;
               }                         
            ccp->mousedown=-1;
               InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);                        
            }
             break;
       case WM_MOUSELEAVE:
            ccp->mousedown=-1;
            ccp->over=-1;
            //hideToolTip(hwnd);
            InvalidateRect(hwnd,NULL,FALSE);        
            UpdateWindow(hwnd);  
             break; 
       case WM_LBUTTONDOWN:
       {
            int xPos = LOWORD(lParam); 
            int yPos = HIWORD(lParam);
           
             
               if(xPos>134 && xPos<154 && yPos<23)
               ccp->mousedown=SAVE;
               else if(xPos>155 && xPos<175 && yPos<23 && !ccp->open)
               ccp->mousedown=OPEN;
               else if(xPos>155 && xPos<175 && yPos<23 && ccp->open)
               ccp->mousedown=CLOSE;
               else if(xPos>176 && yPos<23)
               ccp->mousedown=DESTROY;
               else if(xPos<68 && yPos>29 && yPos<46)
               ccp->mousedown=CONSONANTE;
               else if(xPos>69 && xPos<113 && yPos>29 && yPos<46)
               ccp->mousedown=ASONANTE;
               else if(xPos>16 && xPos<58 && yPos>60 && yPos<72)
               ccp->mousedown=FNV;
               else if(xPos>76 && xPos<120 && yPos>60 && yPos<72)
               ccp->mousedown=FVP;
               else if(xPos>138 && xPos<181 && yPos>60 && yPos<72)
               ccp->mousedown=FVNP;
               else
               ccp->mousedown=-1;
               InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);                         
               
                        
       }
             break; 
       case WM_NCCREATE:
             return TRUE;
       case WM_ERASEBKGND:
       return 1;
       case WM_NCDESTROY:
               free(ccp);
             break;
       case WM_PAINT:
         if(ccp!=NULL)
         {
             paintDicButton(hwnd,ccp);
         }
         break;
    default:
        break;
    }

    return DefWindowProc(hwnd, msg, wParam, lParam);
}







/**************************************
*METHODS ("PUBLIC")
***************************************/
void InitDicButton(HWND parent)
{
 
      WNDCLASSEX wc;

    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = dicButtonProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = sizeof( dicButtonStruc * );
    wc.hInstance     = GetModuleHandle(0);
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_dicButtonName;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

     RegisterClassEx(&wc);
     top=parent;
     
     
     
}




HWND CreateDicButton(HWND parent,int posX,int posY,char* name,HBITMAP bitmap,int maxHeight)
{


 
   HWND thisone=CreateWindowEx(
    0,
    g_dicButtonName, "",
     WS_VISIBLE|WS_CHILD,
    posX, posY, 198, 24,
    parent, NULL, GetModuleHandle(0), NULL
    );  
    dicButtonStruc *ccp = GetDicButtonStruc(thisone);
    ccp = malloc( sizeof(dicButtonStruc) );
    if(ccp == NULL){ return NULL;}
        // Initialize the CustCtrl structure. 
    ccp->hwnd=parent;
    ccp->posX=posX;
    ccp->posY=posY;
    ccp->currentHeight=200;
    ccp->open=FALSE;
    ccp->over=-1;
    ccp->mousedown=-1;
    ccp->consonant=TRUE;
    ccp->word=name;
    ccp->reading=FNV;
    ccp->bitmap=bitmap;
    ccp->maxHeight=maxHeight;
     SetDicButtonStruc(thisone, ccp);  	       
return thisone;
  
     
}


