/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/



/* ***********************************************************************************************
*editURL.c													
*(c)Eduardo Rodriguez 2005																
*																					
*porpuse:  This is the control that actually shows the results of the search and can
*          be clicked to do an online search if the computer is online
*history:	21/09/2005 created	
TODO
wheel scroll
underline current selection
keyboard navigation		
make indexes etc arrays for ease 											
*********************************************************************************************** */


#include <windows.h>
#include <stdio.h>
#include "controles/MEControls.h"
#include "editURL.h"
#include "internet.h"
#include "fonetica.h"


/*************************
*DATA MEMBERS
**************************/


//info for every instance
typedef struct _eURL
{
    int width;               
    int height; 
    int currentSel;          //where id the mouse over
    int fontSize;
    int sil;
    int VoH;
    int flags;
    char* fontName; 
    char* filename;          //word we are looking for
    int showing;             //what are we showing? FVNP etc
    int index[6];           //first word showing in CFNV etc
    int size[6];            //size in bytes of the file containing the CFNV results
    BOOL pressed;           //is the mouse pressed?
    BOOL tracking;          //are we tracking the mouse?
    HANDLE h[6];            //handle to the file containing the CFNV results     
    HWND  hwnd;              //handle to parent 
    HWND scrollbar;          //handle to scrollbar
    HWND hfocus;             //handle to window that had the focus previously
    HWND hpopup;
    HWND hinternet;
}eURL;


const char g_eURL[]="eURL";  //class name
extern HDC memdc;            //memdc intialized in global for double buffering
extern HBITMAP bm;           //bitmap containing graphics
extern BOOL searching;
static char line[80];


//////////////////////////////////////////////////////////////////////////////////////
/***********************************METHODS ("PRIVATE")*****************************/
///////////////////////////////////////////////////////////////////////////////////////
//Set and retrieve window info
static eURL*  GetEURL(HWND hwnd)
{
    return (eURL *)GetWindowLong(hwnd, 0);
}

static void SetEURL(HWND hwnd, eURL *ccp)
{
    SetWindowLong(hwnd, 0, (LONG)ccp);
}


/******************************
*OPEN the files
*******************************/
//when creating, open the six files
static void openFiles(eURL* ccp)
{
     char filenames[6][MAX_PATH];
     int kk,ll;
     ccp->flags=getFonetica();
     for(kk=0;kk<6;kk++)
     for(ll=0;ll<MAX_PATH;ll++)
     filenames[kk][ll]='\0';
     
     sprintf(filenames[0],"metemp/%s%d%d-1-%d-c.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);
     sprintf(filenames[1],"metemp/%s%d%d-2-%d-c.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);
     sprintf(filenames[2],"metemp/%s%d%d-3-%d-c.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);  
     sprintf(filenames[3],"metemp/%s%d%d-1-%d-a.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);    
     sprintf(filenames[4],"metemp/%s%d%d-2-%d-a.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);    
     sprintf(filenames[5],"metemp/%s%d%d-3-%d-a.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);

     for(kk=0;kk<6;kk++)
     {
         ccp->h[kk] = CreateFile(filenames[kk], GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_FLAG_RANDOM_ACCESS, 0); 
         ccp->size[kk] = GetFileSize(ccp->h[kk], 0);   
     }

}




/******************************
*CLOSE the files
********************************/
//close and erase the siz files when window is destroyed
static void closeFiles(eURL* ccp)
{ 
     char filenames[6][MAX_PATH];
     int kk,ll;
     for(kk=0;kk<6;kk++)
     for(ll=0;ll<MAX_PATH;ll++)
     filenames[kk][ll]='\0';
     
     sprintf(filenames[0],"metemp/%s%d%d-1-%d-c.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);
     sprintf(filenames[1],"metemp/%s%d%d-2-%d-c.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);
     sprintf(filenames[2],"metemp/%s%d%d-3-%d-c.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);  
     sprintf(filenames[3],"metemp/%s%d%d-1-%d-a.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);    
     sprintf(filenames[4],"metemp/%s%d%d-2-%d-a.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);    
     sprintf(filenames[5],"metemp/%s%d%d-3-%d-a.me",ccp->filename,ccp->VoH,ccp->sil,ccp->flags);
  
     for(kk=0;kk<6;kk++)
     {
         CloseHandle(ccp->h[kk]);
         DeleteFile(filenames[kk]);       
     }
}


/********************************
*SEARCH internet for currently selected item's meaning
*****************************************************/
static void searchInternet(eURL* ccp)
{
  if(!searching)
  {      
    int its=ccp->currentSel,kk,jj=0;
    unsigned int from=its*(80*sizeof(char));
    ULONG numread;
    SetFilePointer(ccp->h[ccp->showing], from, NULL, FILE_BEGIN); 
    ReadFile(ccp->h[ccp->showing], line, 80*sizeof(char), &numread, 0);
    for(kk=40;kk<80;kk++)
    {
        if(line[kk]!='0')
        line[jj]=line[kk];
        else
        line[jj]='\0';
        line[kk]='\0';
        jj++;            
    }
    if(strlen(line)>0)
    ccp->hinternet=CreateInternet(ccp->hwnd,30,30, 400,200,line);     
  }  
       
}


/*****************************
*PAINT
*****************************/

static void paintEURL(HWND hwnd,eURL* ccp)
{
    //blablabla
    PAINTSTRUCT Ps;
    HDC hDC = BeginPaint(hwnd, &Ps);
    HDC MemDC= CreateCompatibleDC(hDC);
    HFONT hf = CreateFont(ccp->fontSize, 0, 0, 0,0, FALSE, 0, 0, 0, 0, 0, 0, 0, ccp->fontName);   

    //some variables
    unsigned int size=0;        //size of current file
    unsigned int toread=0;      //how much we need to read to fill current window,in bytes
    unsigned int from=0;        //from where in bytes we need to read
    int index=0;                //whats the first element showing in this window
    HWND filetr=NULL;           //whats the handle to this windows file
    int lines=0;
    
    
    //depending on wich file we are showing, use adecuate info
    from=ccp->index[ccp->showing]*(80*sizeof(char));
    size=ccp->size[ccp->showing];
    filetr=ccp->h[ccp->showing];
    index=ccp->index[ccp->showing];
    //how many bytes do we need to read to fill the window?
    toread=(ccp->height/ccp->fontSize+1)*(sizeof(char)*80);
    
    //set scrollbar parameters
    setdoclengthMEScroll(ccp->scrollbar,size/(80*sizeof(char)));
    setposMEScroll(ccp->scrollbar,index);
    
    //create a buffer large enough to hold all we have to read
    char buffer[toread/sizeof(char)];
    //and another to hold every line
    char line[80];
    int kk=0,ll=0,pp=3+ccp->fontSize,qq=0;
    ULONG numread;
    
    //don't read unnecessary stuff
    if(toread>size-index*80*sizeof(char))
        toread=size-index*80*sizeof(char);
        
    //and finally read the appropiate portion of the file
    SetFilePointer(filetr, from, NULL, FILE_BEGIN); 
    ReadFile(filetr, buffer, toread, &numread, 0);
    
    //now do some bg painting
    SelectObject(memdc,hf);          //font
    SelectObject(MemDC,bm);          //bitmap
    COLORREF c1,c2,c3,c4,c5;               //some colors
    HBRUSH bg,bg2;                       //a brush
    HPEN fore,fore2,dash;                       //a pen
    c1=GetPixel(MemDC,8,0);          //find out bg color
    c2=GetPixel(MemDC,9,0);          //find out font color
    c3=GetPixel(MemDC,10,0);         //find out first line (Nro results) color
    c4=GetPixel(MemDC,12,0);         //selected text color
    c5=GetPixel(MemDC,13,0);         //selection bg color
    
    bg=CreateSolidBrush(c1);         //create the brush
    fore=CreatePen(PS_SOLID, 1, c2); //and pen
    bg2=CreateSolidBrush(c5);//brush for selection
    fore2=CreatePen(PS_SOLID,1,c5);//and pen
    dash=CreatePen(PS_DOT,1,c1);
    SelectObject(memdc,bg);          //select them
    SelectObject(memdc,fore);
    Rectangle(memdc,0,0,ccp->width,ccp->height);//paint bg
 
    //set colors for text
    SetBkColor(memdc, c1);
    SetTextColor(memdc, c2);
    
    lines=ccp->index[ccp->showing];
    //paint buffer
    for(kk=0;kk<toread/sizeof(char);kk++)
    {
      if(buffer[kk]!='0' && ll<40)
      {
          line[qq]=buffer[kk];
          qq++;
      }
      ll++;
      if(ll==80)
      {
          if(lines==ccp->currentSel)
          {
              SelectObject(memdc,bg2);
              SelectObject(memdc,fore2);
              Rectangle(memdc,1,pp,ccp->width-1,pp+ccp->fontSize);    

              SetTextColor(memdc, c4); 
              SetBkColor(memdc,c5);
              HFONT hff = CreateFont(ccp->fontSize, 0, 0, 0,0, 0, TRUE, 0, 0, 0, 0, 0, 0, ccp->fontName);   
              SelectObject(memdc,hff);
              TextOut(memdc,4,pp,line,qq); 
              
              if(ccp->pressed)
              {
                  SelectObject(memdc,dash);
                  MoveToEx(memdc,2,pp+2,NULL);
                  LineTo(memdc,2,pp+ccp->fontSize-2);
                  LineTo(memdc,ccp->width-14,pp+ccp->fontSize-2);
                  LineTo(memdc,ccp->width-14,pp+2);
                  LineTo(memdc,2,pp+2);
              }
                                                                   
              SetTextColor(memdc,c2);
              SetBkColor(memdc,c1);
              DeleteObject(hff);
              SelectObject(memdc,hf);
              SelectObject(memdc,bg);
              SelectObject(memdc,fore);
                                                 
          }    
          else      
              TextOut(memdc,4,pp,line,qq); 
          pp+=ccp->fontSize;  
          ll=0;
          qq=0;
          lines++;        
      }                                           
    }
    
    //clean line buffer
    for(kk=0;kk<80;kk++)
    line[kk]='\0';
    
    //show number of result
    sprintf(line,"%d Resultados",size/(80*sizeof(char)));
    SetTextColor(memdc,c3);
    TextOut(memdc,4,3,line,strlen(line));     

    MoveToEx(memdc,0,ccp->height-1,NULL);
    LineTo(memdc,ccp->width,ccp->height-1);
        
    //double buffering               
    BitBlt(hDC, 0, 0,ccp->width,ccp->height , memdc, 0, 0, SRCCOPY); 
    
    //clean up          
    DeleteDC(hDC);
    DeleteObject(hf);
    DeleteObject(fore);
    DeleteObject(bg);
    DeleteObject(bg2);
    DeleteObject(fore2);
    DeleteObject(dash);
    DeleteDC(MemDC);
    EndPaint(hwnd, &Ps);                    
}



/******************************
*CALLBACK PROCEDURE
*******************************/

LRESULT CALLBACK eURLProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    eURL *ccp = GetEURL(hwnd);
    switch(msg)
    {
        
        
        //-------------------------WM_NCHITTEST---------------------------------       
        case WM_NCHITTEST:
       {
             //HWND prev=SetFocus(hwnd);
             //if(prev!=hwnd)
             //    ccp->hfocus=prev;
             if(!ccp->tracking)
             {
                 TRACKMOUSEEVENT tr;
                 tr.cbSize=sizeof(tr);
                 tr.dwFlags=TME_LEAVE;
                 tr.hwndTrack=hwnd;
                 tr.dwHoverTime=HOVER_DEFAULT;
                 ccp->tracking=TRUE;
                 TrackMouseEvent(&tr);                       
                                             
             }
             //check who is the mouse over and paint if necessary
             UINT uHitTest = DefWindowProc(hwnd, WM_NCHITTEST, wParam, lParam);
             int yPos = HIWORD(lParam);
             RECT wind; 
             GetWindowRect(hwnd,&wind);
             if( uHitTest==HTCLIENT && yPos-wind.top>ccp->fontSize+3)
             { 
                //compute element 
                int formerElement=ccp->currentSel;
                ccp->currentSel=ccp->index[ccp->showing]+(((yPos-wind.top)-(ccp->fontSize+3))/ccp->fontSize);
                if(formerElement!=ccp->currentSel)
                {
                	InvalidateRect(hwnd,NULL,FALSE);        
                    UpdateWindow(hwnd);                                                        
                }
             }
             return uHitTest;
        }      
        break; 
        
        
        //--------------------------WM_LBUTTONUP-------------------------------------
        case WM_LBUTTONUP:
            if(ccp->pressed)
            {                 
                ccp->pressed=FALSE;
       	        InvalidateRect(hwnd,NULL,FALSE);        
                UpdateWindow(hwnd);   
                searchInternet(ccp);
            }                                                     
        break;



        
        
        //--------------------------WM_MOUSELEAVE-----------------------------------
        case WM_MOUSELEAVE:
            ccp->pressed=FALSE;
            ccp->tracking=FALSE;
            ccp->currentSel=-1;
            if(ccp->hfocus!=NULL)
                SetFocus(ccp->hfocus);
       	    InvalidateRect(hwnd,NULL,FALSE);        
            UpdateWindow(hwnd);                                                                     
        break;


        //--------------------------WM_ERASEBKGND-----------------------------------
        case WM_ERASEBKGND:
        return 1;
         
        
        //---------------------------WM_LBUTTONDOWN-------------------------------- 
        case WM_LBUTTONDOWN:
        {
            SetFocus(hwnd);
            ccp->pressed=TRUE;
           	InvalidateRect(hwnd,NULL,FALSE);        
            UpdateWindow(hwnd);     
        }                                                      
        break;

        case WM_RBUTTONDOWN:
        {
            SetFocus(hwnd);
  
        }                                                      
        break;

        //---------------------------ME_SCROLL_VERTICAL------------------------------        
        case ME_SCROLL_VERTICAL:
             SetFocus(hwnd);
             ccp->index[ccp->showing]=wParam;             
             InvalidateRect(hwnd,NULL,FALSE);        
             UpdateWindow(hwnd);              
        break;
 
 
 
                
        //--------------------------------WM_NCDESTROY-------------------------------
        case WM_NCDESTROY:
            closeFiles(ccp);
            free(ccp);
        break;
        
        
        //---------------------------------WM_PAINT----------------------------------
        case WM_PAINT:
            paintEURL(hwnd,ccp);
        break;
        
        //----------------------WM_MOUSEWHEEL-------------------------------------
        case WM_MOUSEWHEEL:
             {
              int max=(ccp->size[ccp->showing]/(80*sizeof(char)))-(ccp->height-(ccp->fontSize+3))/ccp->fontSize;
              if(max<0)max=0;
              ccp->index[ccp->showing]+=(short)HIWORD(-wParam)/120;
              if(ccp->index[ccp->showing]<0)
                  ccp->index[ccp->showing]=0;
              else if(ccp->index[ccp->showing]>max)
                  ccp->index[ccp->showing]=max;
              setposMEScroll(ccp->scrollbar,ccp->index[ccp->showing]);
 	          InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);    
              }               
        return 0;
       


        
        //blablabla
        default:
        break;
    }
    return DefWindowProc(hwnd, msg, wParam, lParam);
}



////////////////////////////////////////////////////////////////////////////////////
/****************************METHODS ("PUBLIC")************************************/
////////////////////////////////////////////////////////////////////////////////////

/*****************************
*REGISTER THE CLASS

return void;
HWND parent: any valid handle
********************************/
void InitEURL(HWND parent)
{
 
    WNDCLASSEX wc;

    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = eURLProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = sizeof( eURL * );
    wc.hInstance     = GetModuleHandle(0);
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_eURL;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

    RegisterClassEx(&wc); 
    InitInternet(parent);
}


/**************************
*CREATE editURL

return: handle to the eURL created;
see editURL.h  
for an explanation of the paramaters
***************************/

HWND CreateEURL(HWND parent,int posX,int posY, int w,int h,char* fontName,int fontSize,char* filename,int sil,int VoH)
{

 
   HWND thisone=CreateWindowEx(0,g_eURL, "",WS_VISIBLE|WS_CHILD|WS_CLIPCHILDREN,
       posX, posY, w, h,parent, NULL, GetModuleHandle(0), NULL);  
   eURL *ccp= GetEURL(thisone);
   ccp = malloc(sizeof(eURL));
   if(ccp == NULL) return NULL;
   
   // Initialize the CustCtrl structure. 
   ccp->width=w;
   ccp->height=h;
   ccp->currentSel=-1;
   ccp->fontName=fontName;
   ccp->fontSize=fontSize;
   ccp->showing=CFNV;
   ccp->sil=sil;
   ccp->VoH=VoH;
   ccp->index[0]=0;
   ccp->index[1]=0;
   ccp->index[2]=0;
   ccp->index[3]=0;
   ccp->index[4]=0;
   ccp->index[5]=0; 
   ccp->h[0]=NULL;
   ccp->h[1]=NULL;
   ccp->h[2]=NULL;
   ccp->h[3]=NULL;
   ccp->h[4]=NULL;
   ccp->h[5]=NULL; 
   ccp->flags=0;
   ccp->tracking=FALSE;
   ccp->hfocus=NULL; 
   ccp->pressed=FALSE;   
   ccp->filename=filename; 
   ccp->hwnd=HWND_DESKTOP;
   openFiles(ccp); 
   ccp->scrollbar=CreateMEScroll(thisone,w-12,1,11,h-2,200,0,h/fontSize,TRUE);    
       
   SetEURL(thisone, ccp);

    
return thisone;  
}


/**************************
*setShowingEURL

return: void
sets which window we are showing
see editURL.h  
for an explanation of the paramaters
***************************/
void setShowingEURL(int what,HWND who)
{
    eURL *ccp = GetEURL(who);
    ccp->showing=what;
    ccp->currentSel=-1;
    InvalidateRect(who,NULL,FALSE);        
    UpdateWindow(who);      
}

void setHeight(HWND hwnd,int y)
{
    eURL *ccp = GetEURL(hwnd);     
    ccp->height=y; 
    int max=(ccp->size[ccp->showing]/(80*sizeof(char)))-(ccp->height-(ccp->fontSize+3))/ccp->fontSize;
    if(max<0)max=0;
    SetWindowPos(hwnd,0,0,0,ccp->width,y,SWP_NOMOVE); 
    resizeMEScroll(ccp->scrollbar,11,y-2);
    setscreensizeMESCroll(ccp->scrollbar, (y-(3+ccp->fontSize))/ccp->fontSize);
    if(ccp->index[ccp->showing]>max)
    {
        ccp->index[ccp->showing]=max;
        setposMEScroll(ccp->scrollbar,ccp->index[ccp->showing]);
    }
    InvalidateRect(hwnd,NULL,FALSE);        
    UpdateWindow(hwnd);  
     
}

void DestroyFiles(HWND hwnd)
{
    eURL *ccp = GetEURL(hwnd);     
    closeFiles(ccp);     
}


