/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/


/* ***********************************************************************************************
*html.c													
*(c)Eduardo Rodriguez 2005																
*																					
*porpuse:   reads and shows the rae results
*history:	27/09/2005 created								
*********************************************************************************************** */


#include <windows.h>
#include "html.h"
#include "controles/MEControls.h"

/*************************
*DATA MEMBERS
**************************/

//info for every instance
typedef struct _html
{
    int width;             
    int height; 
    int lines;
    int index;
    char *text;
    HWND scroll; 
}html;


const char g_html[]="html";

extern HDC memdc;
extern HBITMAP bm;


/////////////////////////////////////////////////////////////////////////////////////////
/************************************METHODS ("PRIVATE")********************************/
/////////////////////////////////////////////////////////////////////////////////////////
//set and retrieve window info
static html*  GetHtml(HWND hwnd)
{
    return (html *)GetWindowLong(hwnd, 0);
}


static void SetHtml(HWND hwnd, html *ccp)
{
    SetWindowLong(hwnd, 0, (LONG)ccp);
}



/*************************
*PAINT
**************************/
//very simple painting proc, to be custumized. It does some
//calculations one shouldn't mess with, though


static void paintHtml(HWND hwnd, html *ccp)
{
    //make sure it has been initiliazed 
    if(ccp!=NULL)
    {
         //blabla        
         PAINTSTRUCT Ps;
         HDC hDC = BeginPaint(hwnd, &Ps);
         HDC MemDC= CreateCompatibleDC(hDC);
         COLORREF c1,c2;
         HBRUSH bk1;
         HPEN p1;
         HFONT hf = CreateFont(16, 0, 0, 0,0, FALSE, 0, 0, 0, 0, 0, 0, 0, "Times New Roman");   
         int kk=0,clines=0,charl=0,lpos=3;
         char line[1000];
 
         SelectObject(MemDC,bm);
         SelectObject(memdc,hf);
         c1=GetPixel(MemDC,8,0);          //find out bg color
         c2=GetPixel(MemDC,9,0);          //find out font color         
         
         bk1=CreateSolidBrush(c1);
         p1=CreatePen(PS_SOLID, 1, c2); 
         
         SelectObject(memdc,bk1);
         SelectObject(memdc,p1);
         
         Rectangle(memdc,0,0,ccp->width,ccp->height);
         
         //write
         SetBkColor(memdc,c1);
         SetTextColor(memdc,c2);
         
         if(ccp->text!=NULL)
         {
              memset(line,'\0',1000);
              while(ccp->text[kk]!='\0')
              {
                  if(ccp->text[kk]=='\n' || (ccp->text[kk]==' ' && charl>40))
                  {
                      clines++;
                      if(clines>ccp->index)
                      {                
                          TextOut(memdc,5,lpos,line,charl);
                          lpos+=16;
                      }
                      memset(line,'\0',1000);
                      charl=0;                          
                
                      
                  }
                  else
                  {
                      line[charl]=ccp->text[kk];
                      charl++;  
                  }                           
              kk++;                         
              } 
               TextOut(memdc,5,lpos,line,charl);
                                                                        
         }
         
         MoveToEx(memdc,0,ccp->height-1,NULL);
         LineTo(memdc,ccp->width,ccp->height-1);
 
         //double buffering               
         BitBlt(hDC, 0, 0,ccp->width,ccp->height , memdc, 0, 0, SRCCOPY); 
 
         //blabla 
         DeleteObject(bk1);
         DeleteObject(p1);
         DeleteObject(hf);
         DeleteDC(hDC);
         DeleteDC(MemDC);
         EndPaint(hwnd, &Ps);                   
    }     
}






/******************************
*CALLBACK PROCEDURE
*******************************/

LRESULT CALLBACK htmlProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    html *ccp = GetHtml(hwnd);
    switch(msg)
    {
     
        //-------------------------WM_NCHITTEST--------------------------------       
        case WM_NCHITTEST:
 
        break; 
        
        
        //--------------------------WM_NCAVTIVATE----------------------------------
        //if the message doesn't come from the scrollbar and if it is selfdestructive, destroy
        case WM_NCACTIVATE:

        break; 
        
        
        //------------------------WM_LBUTTONDOWN-------------------------------------
         case WM_LBUTTONDOWN:
              SetFocus(hwnd);
         break;

        //--------------------------WM_ERASEBKGND-----------------------------------
        case WM_ERASEBKGND:
        return 1;
                          
         
         //----------------------WM_MOUSEWHEEL-------------------------------------
         case WM_MOUSEWHEEL:
             {
              ccp->index+=(short)HIWORD(-wParam)/120;
              if(ccp->index<0)ccp->index=0;
              else if(ccp->index>ccp->lines-ccp->height/16)
              ccp->index=ccp->lines-ccp->height/16;
              setposMEScroll(ccp->scroll,ccp->index);
 	          InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);    
              }                    
         return 0;
         
         
         //------------------------ME_SCROLL_VERTICAL-------------------------------
         case ME_SCROLL_VERTICAL:
              ccp->index=wParam;
 		      InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);                                 
         break;
    
        
         //-------------------------WM_NCDESTROY------------------------------------
         case WM_NCDESTROY:
             free(ccp);
         break;
         
         
         //---------------------------WM_PAINT-------------------------------------
         case WM_PAINT:
             paintHtml(hwnd,ccp);
         break;
         
         
         //----------------------------WM_KEYDOWN-----------------------------------
         case WM_KEYDOWN:
              
           //down arrow
           if(wParam== VK_DOWN)
           {      

           }
           
           //up arrow
           else if(wParam==VK_UP )
           {

           }
           
         
         //-----------------------------WM_CHAR----------------------------------
         case WM_CHAR:
             //if it's return
             if(wParam=='\r')
             {
             }          
         break;
         
         
         //blabla    
         default:
         break;
    }
    return DefWindowProc(hwnd, msg, wParam, lParam);
}



///////////////////////////////////////////////////////////////////////////////////////
/******************************METHODS ("PUBLIC")************************************/
//////////////////////////////////////////////////////////////////////////////////////

/*****************************
*REGISTER THE CLASS

return void;
HWND parent: any valid handle;
********************************/
void InitHtml(HWND parent)
{ 
    WNDCLASSEX wc;

    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         =  0;
    wc.lpfnWndProc   = htmlProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = sizeof( html * );
    wc.hInstance     = GetModuleHandle(0);
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_html;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);
    RegisterClassEx(&wc); 
}






/*****************************
*CREATE THE WINDOW

return handle to the newly created list;
See melist.h or MEControls.h for and explanation
of the parameters.
********************************/
HWND CreateHtml(HWND parent,int posX,int posY, int w,int h, char* strings)
{

    int kk=0;
    HWND thisone=CreateWindowEx(0,g_html, "",WS_CHILD|WS_CLIPCHILDREN ,posX, posY, 
        w, h,parent, NULL, GetModuleHandle(0), NULL);   
    html *ccp = GetHtml(thisone);
    ccp = malloc( sizeof(html) );
    if(ccp == NULL) return NULL;
    
    // Initialize the CustCtrl structure. 
    ccp->height=h;
    ccp->width=w;
    ccp->text=strings;
    ccp->index=0;
     SetHtml(thisone,ccp);

       ccp->scroll=CreateMEScroll(thisone,ccp->width-12,1,11,ccp->height-2,0,0,h/16,TRUE);    
    
 
    return thisone;
     
}


void setText(HWND hwnd,char *text)
{
    html *ccp = GetHtml(hwnd);
    ccp->lines=0;
    ccp->text=text;
    ccp->index=0;
    int kk=0,jj=0;
    //count lines    
    while(text[kk]!='\0')
    {
        if(text[kk]=='\n' || (text[kk]==' ' && jj>40))
        {
            ccp->lines++;
            jj=0;
        }    
        kk++;    
        jj++;                 
    }
    ccp->lines++;
    setdoclengthMEScroll(ccp->scroll, ccp->lines); 
    setposMEScroll(ccp->scroll, 0);
    InvalidateRect(hwnd,NULL,FALSE);        
    UpdateWindow(hwnd);                     
   
}

HWND getScrollBar(HWND hwnd)
{
    html *ccp = GetHtml(hwnd);
    return ccp->scroll;     
}

