/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/


#include <windows.h>
#include "internet.h"
#include "raesearch.h"
#include "recursos.h"
#include "html.h"


#define DOWN 1
#define UP 0
#define OVER 2
#define RIGHT 2
#define ID_FILE_EXIT 0

/*************************
*DATA MEMBERS
**************************/

//info for every instance
typedef struct _internet
{
    int width;
    int height;
    int cerrar;
    int minimizar;
    int position;  
    char *word;
    HWND html;

}internet;


const char g_internet[]="internet";
extern HBITMAP bm;
extern HDC memdc;
BOOL searching=FALSE;
static BOOL thereis=FALSE;
static HWND thisin=NULL;

///////////////////////////////////////////////////////////////////////////////////////
/**********************************METHODS ("PRIVATE")*******************************/
////////////////////////////////////////////////////////////////////////////////////////
//set and retrieve window info
static internet*  GetInternet(HWND hwnd)
{
    return (internet *)GetWindowLong(hwnd, 0);
}

static void SetInternet(HWND hwnd, internet *ccp)
{
    SetWindowLong(hwnd, 0, (LONG)ccp);
}

/*****************************
*PAINT
*****************************/


static void paintInternet(HWND hwnd,internet* ccp)
{
     //blablabla
     PAINTSTRUCT Ps;
     HDC hDC = BeginPaint(hwnd, &Ps);
     HDC MemDC= CreateCompatibleDC(hDC);
     SelectObject(MemDC,bm);
     int kk;
     //get colors
     COLORREF c1,c2,c3,c4,c5,c6;
     c5=GetPixel(MemDC,100,75); //status bar borde
     c6=GetPixel(MemDC,100,74); //status bar inside
     c4=GetPixel(MemDC,9,0);    //texto "palabra original"
     c3=GetPixel(MemDC,10,0);   //texto , palabra
     c1=GetPixel(MemDC,0,335);  //bg
     c2=GetPixel(MemDC,92,168); //borde
     HPEN p1=CreatePen(PS_SOLID, 1, c2);
     HBRUSH b1=CreateSolidBrush(c1);
     HPEN p2=CreatePen(PS_SOLID, 1, c5);
     HBRUSH b2=CreateSolidBrush(c6);
     HFONT hf = CreateFont(16, 0, 0, 0,0, FALSE, 0, 0, 0, 0, 0, 0, 0, "Times New Roman");   
     
     SelectObject(memdc,p1);
     SelectObject(memdc,b1); 
     SelectObject(memdc,hf);
     
     //bg
     Rectangle(memdc,0,0,ccp->width,ccp->height);
 
     //title
     for(kk=0;kk<ccp->width;kk+=50)
     BitBlt(memdc, kk, 0, 50,18 , MemDC, 92, 169, SRCCOPY);
     
     BitBlt(memdc, 5, 0, 82,18 , MemDC, 148, 169, SRCCOPY);
     
     
     MoveToEx(memdc,0,0,NULL);
     LineTo(memdc,0,20);
     MoveToEx(memdc,ccp->width-1,0,NULL);
     LineTo(memdc,ccp->width-1,20); 

     //tilte buttons
     
		     //close button
             if(ccp->cerrar==UP)
             BitBlt(memdc, ccp->width-19, 4, 12, 12, MemDC, 11, 11, SRCCOPY);
             else if(ccp->cerrar==DOWN)
             BitBlt(memdc, ccp->width-19, 4, 12, 12, MemDC, 23, 11, SRCCOPY);
             else
             BitBlt(memdc, ccp->width-19, 4, 12, 12, MemDC, 35, 11, SRCCOPY);
             //boton minimizar
             if(ccp->minimizar==UP)
             BitBlt(memdc, ccp->width-32, 4, 12, 12, MemDC, 11, 23, SRCCOPY);
             else if(ccp->minimizar==DOWN)
             BitBlt(memdc, ccp->width-32, 4, 12, 12, MemDC, 23, 23, SRCCOPY);
             else
             BitBlt(memdc, ccp->width-32, 4, 12, 12, MemDC, 35, 23, SRCCOPY);


     //text
     SetBkColor(memdc,c1);  
     SetTextColor(memdc,c4);  
     TextOut(memdc,30,30,"Palabra original: ",18);  
     SetTextColor(memdc,c3);       
     TextOut(memdc,130,30,ccp->word,strlen(ccp->word));

     //if its searching the internet
     if(searching)
     {
         SetTextColor(memdc,c4);  
         TextOut(memdc,130,80,"Buscando...",11); 
         
         SelectObject(memdc,b2);
         SelectObject(memdc,p2);
         Rectangle(memdc,(ccp->width-250)/2,120,(ccp->width-250)/2+250,139);
         
         BitBlt(memdc,(ccp->width-250)/2+ccp->position , 121,26,17 , MemDC, 101, 74, SRCCOPY);                        
     }
     



     //double buffering
     BitBlt(hDC, 0, 0,ccp->width,ccp->height , memdc, 0, 0, SRCCOPY); 

     //clen up
     DeleteDC(hDC);
     DeleteDC(MemDC);
     DeleteObject(p1);
     DeleteObject(b1);
     DeleteObject(p2);
     DeleteObject(b2);
     DeleteObject(hf);
     EndPaint(hwnd, &Ps);                       
}



/**************************
*THREAD
**************************/
DWORD WINAPI me_startpainting(LPVOID iValue)
{
  internet *ccp = GetInternet(thisin);
  BOOL forward=TRUE;
  search("buscon.rae.es",ccp->word);

  
  while(searching)
  {
  
      if(forward)
      {
          ccp->position++;
          if(ccp->position>223)
          forward=FALSE;           
      }
      else
      {
          ccp->position--;
          if(ccp->position<1)
          forward=TRUE;    
      }
      searching=issearching();        
      InvalidateRect(thisin,NULL,FALSE);        
      UpdateWindow(thisin);  
      Sleep(10); 
      if(!searching)
      {
          
          setText(ccp->html,getResult());
          ShowWindow(ccp->html,SW_SHOW);                          
      }
                
                      
  }
  
          InvalidateRect(thisin,NULL,FALSE);        
          UpdateWindow(thisin);                           
   
      return 0;
      
}






/******************************
*CALLBACK PROCEDURE
*******************************/

LRESULT CALLBACK MEInternetProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  internet *ccp = GetInternet(hwnd);
  switch(msg)
    {
  
  
    //---------------------------WM_NCHITTEST-------------------------           
    case WM_NCHITTEST:
    {
      //find coordinates   
      int xPos = LOWORD(lParam); 
      int yPos = HIWORD(lParam);
      int pos,w,h;
      RECT wind;
      GetWindowRect(hwnd,&wind);
      yPos-=wind.top;
      xPos-=wind.left;


      //it cerrar
      if( yPos>4 && yPos<16 && xPos>ccp->width-19 && xPos<ccp->width-7)
      {
          if(ccp->cerrar!=OVER && ccp->cerrar!=DOWN)
          {
              ccp->cerrar=OVER;
              ccp->minimizar=UP;
              TRACKMOUSEEVENT tr;
              tr.cbSize=sizeof(tr);
              tr.dwFlags=TME_LEAVE;
              tr.hwndTrack=hwnd;
              tr.dwHoverTime=0;
              TrackMouseEvent(&tr);
  		      InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);                   
          }
          return HTCLIENT;
      }
      //if minimizar
      else if(yPos>4 && yPos<16 && xPos>ccp->width-32 && xPos<ccp->width-20 )
      {
          if(ccp->minimizar!=OVER && ccp->minimizar!=DOWN)
          {
              ccp->minimizar=OVER;
              ccp->cerrar=UP;
              TRACKMOUSEEVENT tr;
              tr.cbSize=sizeof(tr);
              tr.dwFlags=TME_LEAVE;
              tr.hwndTrack=hwnd;
              tr.dwHoverTime=0;
              TrackMouseEvent(&tr);
  		      InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);                     
          }
          return HTCLIENT;
      } 
      //if anywhere else in the title bar
      else if(yPos < 20)
      {
          if(ccp->cerrar!=UP || ccp->minimizar!=UP)
          {             
              ccp->cerrar=UP;
              ccp->minimizar=UP;  
              InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);     
          }                 
          return HTCAPTION;  
      }
      //outside the title bar          
      else
      {   
          if(ccp->cerrar!=UP || ccp->minimizar!=UP)
          {
              ccp->cerrar=UP;    
              ccp->minimizar=UP;
  		      InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);                    
          }   
          return DefWindowProc(hwnd, msg, wParam, lParam);                                 
      }
    }
    
    //--------------------------WM_LBUTTONUP------------------------------
    case WM_LBUTTONUP:
         if(ccp->cerrar==DOWN)
         {
             searching=FALSE;
             Sleep(200);
             ccp->cerrar=UP;
             thereis=FALSE;
             DestroyWindow(hwnd);
         }
         else if(ccp->minimizar==DOWN)
         {
             ccp->minimizar=UP;
             InvalidateRect(hwnd,NULL,FALSE);        
             UpdateWindow(hwnd);                   
             ShowWindow(hwnd, SW_MINIMIZE);
         }
    break;
    
    
    //----------------------------WM_MOUSELEAVE----------------------------
    case WM_MOUSELEAVE:
         ccp->cerrar=UP;
         ccp->minimizar=UP;
         InvalidateRect(hwnd,NULL,FALSE);        
         UpdateWindow(hwnd);                    

    break; 
    
    
    //-----------------------------WM_LBUTTONDOWN----------------------
    case WM_LBUTTONDOWN:
         if(ccp->cerrar==OVER)
             ccp->cerrar=DOWN;
         else if(ccp->minimizar==OVER)
             ccp->minimizar=DOWN;
         InvalidateRect(hwnd,NULL,FALSE);        
         UpdateWindow(hwnd);                    
    break; 
    
    //------------------------------WM_MOUSEMOVE-----------------------------
    case WM_MOUSEMOVE:

    break;
    
    
    //--------------------------------WM_NCDESTROY--------------------------
    case WM_NCDESTROY:
        free(ccp);
    break;
 
        //--------------------------WM_ERASEBKGND-----------------------------------
        case WM_ERASEBKGND:
        return 1;
             
    
    //--------------------------------WM_PAINT-----------------------------
    case WM_PAINT:
        paintInternet(hwnd,ccp);
    break;
    
        //--------------------------WM_ERASEBKGND-----------------------------------
       // case WM_ERASEBKGND:
       // return 1;
    
    
    
    //blablabla
    default:
        break;
  }

  return DefWindowProc(hwnd, msg, wParam, lParam);
}



////////////////////////////////////////////////////////////////////////////////////////
/*******************************METHODS ("PUBLIC")***********************************/
///////////////////////////////////////////////////////////////////////////////////////

/*****************************
*REGISTER THE CLASS

return void;
HWND parent: any valid handle;
********************************/
void InitInternet(HWND parent)
{
    WNDCLASSEX wc;
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = MEInternetProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = sizeof( internet * );
    wc.hInstance     = GetModuleHandle(0);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_internet;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);
    RegisterClassEx(&wc); 
    InitHtml(parent);
}






/**************************
*CREATE 

return: handle to the window created;

***************************/
HWND CreateInternet(HWND parent,int posX,int posY, int w,int h,char* word)
{
   //if there's not a window there already
   if(!thereis)   
   {
       HWND thisone=CreateWindowEx(0,g_internet, "M&E-internet",WS_POPUP|WS_VISIBLE|WS_CLIPCHILDREN|WS_SYSMENU,
           posX, posY, w, h,HWND_DESKTOP, NULL, GetModuleHandle(0), NULL);  
       internet *ccp = GetInternet(thisone);
       ccp = malloc( sizeof(internet) );
       if(ccp == NULL) return NULL;
       
       // Initialize the MEScroll structure. 
       ccp->width=w;
       ccp->height=h;
       ccp->word=word;
       ccp->cerrar=UP;
       ccp->minimizar=UP;
       ccp->position=0;
       searching=TRUE;
  

       thereis=TRUE;
       thisin=thisone;
       ccp->html=CreateHtml(thisin,25,60, w-50,h-80, NULL);
       SetInternet(thisone, ccp);
       SendMessage(thisone, WM_SETICON, ICON_SMALL, (LPARAM)LoadImage(NULL, "iconosquare.ico", IMAGE_ICON, 16, 16, LR_LOADFROMFILE)); 
       CreateThread(NULL,0,me_startpainting,0,0,NULL);     
       return thisone;   
   
   }
   
   //if there is one...
   else
   {

         internet *ccp = GetInternet(thisin);
         
         if(!searching)
         {
             InvalidateRect(thisin,NULL,FALSE);        
             UpdateWindow(thisin);
             ccp->position=0;  
             ShowWindow(ccp->html,SW_HIDE);
             searching=TRUE;
             CreateThread(NULL,0,me_startpainting,0,0,NULL);
         }              
         return thisin;
   }
}






