/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/


/***************************************************************************
*Main, claro. Has the logic for the main frame, hiding, docking and stuff
*(C)Eduardo Rodriguez 2005
*Ver detalles de la licencia GPL para los derechos de uso
*

****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include "controles/MEControls.h"
#include "recursos.h"
#include "diccionario.h"
#include "editURL.h"
#include "buttonManager.h" 
#include "menu.h"  
#include "about.h"
#include "fonetica.h"
#include "settings.h"

/********************************************************************
*DEFINES and declare
*********************************************************************/
#define DOWN 1
#define UP 0
#define OVER 2
#define OVER2 10                   //is it over while down?
#define RIGHT 2
#define ID_FILE_EXIT 0

LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);



/*****************************************************************
*DATA MEMBERS
*******************************************************************/
//stuff for painting
extern HPEN hpen_black,hpen_white,hpen_darktop,hpen_medtop,hpen_lowtop,hpen_bk;
extern HBRUSH bkBrush;
extern HDC memdc;
extern HBITMAP bm;


static int sizeX=214,sizeY=500,xsizeY=500;      //size of window
static int cerrar= UP ;                         //close button state
static int minimizar= UP ;                      //
int docked=0;                            //is it docked 0=false, 2=RIGTH=true
static int prevY=500;                           //height before docking
static int screenLen=0;                         //length of the screen
static int screenHi=0;                          //height of the screeb
char szClassName[ ] = "MEDiccionario";
static int chincheta=UP;                        //does it hide when docked or go back when not and losing focus?
static int menu=UP;
static BOOL hidden=FALSE;                       //is it hidden?
static BOOL hasfocus=TRUE;                      //does it have the focus?
static HWND htooltips[10];                      //handles to the tooltips. handy to change the position and text when docked
static HWND hmain=NULL;                         //handle to the main window
static int borderSize=0;
static BOOL acoplar=TRUE;
static BOOL ayudas=TRUE;
static int flagsf=0;
static int tthandle=-1;
static int ttchincheta=-1;
static int ttcerrar=-1;
static int ttminimizar=-1;

/************************************
*MAIN
**************************************/
int WINAPI WinMain (HINSTANCE hThisInstance,HINSTANCE hPrevInstance,LPSTR lpszArgument,int nFunsterStil)

{
    //blablabla             
    MSG messages;            
    WNDCLASSEX wincl;  
    int pX,pY;

    //find out screen sizes
    screenLen=GetSystemMetrics(SM_CXSCREEN);
    screenHi=GetSystemMetrics(SM_CYSCREEN);
	initSettings(&flagsf,&sizeX,&sizeY,&pX,&pY,&acoplar,&ayudas);
	setFlags(flagsf);
	//load bitmap with graphics
	bm= LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_BITMAP));      
	
    
    //init the custom controls
    initializeMEControls(HWND_DESKTOP);
    setWorking(ayudas);

    //create the class and register
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;     
    wincl.style = CS_DBLCLKS;                 
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_ICON2));
    wincl.hIconSm = LoadIcon (NULL, MAKEINTRESOURCE(ID_ICON));
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                
    wincl.cbClsExtra = 0;         
    wincl.cbWndExtra = 0;                
    wincl.hbrBackground = bkBrush;
    if (!RegisterClassEx (&wincl))
        return 0;
    hmain = CreateWindowEx (0,szClassName,"M&E Diccionario de Rimas", WS_POPUP|WS_VISIBLE|WS_CLIPCHILDREN|WS_SIZEBOX|WS_SYSMENU,
           pX,pY,sizeX,sizeY,HWND_DESKTOP,NULL,hThisInstance,NULL);
    
    
    
    //show it
    ShowWindow (hmain, nFunsterStil);


    //register the hook. That way I know where tha mouse is all the time
    registerMEHook(hmain);
    InitEURL(hmain);
    //
    
        
    //blablabla
    while (GetMessage (&messages, NULL, 0, 0))
    {
        TranslateMessage(&messages);
        DispatchMessage(&messages);
    }


    return messages.wParam;
}



/**************************************************************
*ANIMATIONS -hiding and showing when docked
**************************************************************/

void animateHide()
{
  int kk;
  for(kk=0;kk<sizeX-borderSize;kk+=borderSize)
  {
    SetWindowPos(hmain,HWND_TOPMOST,screenLen-sizeX+borderSize+kk,-borderSize,sizeX,screenHi+borderSize*2,0);                           
    InvalidateRect(hmain,NULL,FALSE);        
    UpdateWindow(hmain);                                          
  }     
}




void animateShow()
{
  int kk;
  for(kk=0;kk<sizeX-borderSize;kk+=4)
  {
    SetWindowPos(hmain,HWND_TOPMOST,screenLen-kk,-borderSize,sizeX,screenHi+borderSize*2,0);                           
    InvalidateRect(hmain,NULL,FALSE);        
    UpdateWindow(hmain);                                         
  }       
}



/*************************************************
*WINDOW PROC
*************************************************/

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                 
    {
      
      
      
      
      
      
        /********************** WM_NCHITTEST*************************/     
        case WM_NCHITTEST:
        {
           UINT uHitTest = DefWindowProc(hwnd, WM_NCHITTEST, wParam, lParam);
           
           //if hidden, animate to reappear
           if(hidden==TRUE)
           {
            animateShow();
            hidden=FALSE;                
           }
           
           //if the hit is in the client area...
           if(uHitTest==HTCLIENT)
           {
              //get info about locations
              RECT rect;
              int xPos = LOWORD(lParam); 
              int yPos = HIWORD(lParam);
              int offset=0;             //if docked, menu is higher. Thisone will let me know
              if(docked==0)offset=15;   //see?
              GetWindowRect(hwnd,&rect);
              xPos=(xPos-rect.left)-borderSize;  //adjust Pos to window coordinates
              yPos=(yPos-rect.top)-borderSize;
             
              //and now lets see how that affects us
              //1. is it over cerrar? 
              if( yPos>1 && yPos<13 && xPos>sizeX-19 && xPos<sizeX-7 && docked==0)
              {
                if(cerrar!=OVER && cerrar!=DOWN)
                {
                  cerrar=OVER;
                  minimizar=UP;
                  if(chincheta==OVER)
                      chincheta=UP;
                  else if(chincheta==OVER2)
                      chincheta=DOWN;
                  if(menu==OVER)
                      menu=UP;
                  TRACKMOUSEEVENT tr;
                  tr.cbSize=sizeof(tr);
                  tr.dwFlags=TME_LEAVE;
                  tr.hwndTrack=hwnd;
                  tr.dwHoverTime=0;
                  TrackMouseEvent(&tr);
     		      InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);                   
                }
                return HTCLIENT;
              }

              //2. or over minimizing?
              else if(yPos>1 && yPos<13 && xPos>sizeX-32 && xPos<sizeX-20 && docked==0)
              {
                if(minimizar!=OVER && minimizar!=DOWN)
                {
                  minimizar=OVER;
                  cerrar=UP;
                  if(chincheta==OVER)
                      chincheta=UP;
                  else if(chincheta==OVER2)
                      chincheta=DOWN;
                  if(menu==OVER)
                      menu=UP;
                  TRACKMOUSEEVENT tr;
                  tr.cbSize=sizeof(tr);
                  tr.dwFlags=TME_LEAVE;
                  tr.hwndTrack=hwnd;
                  tr.dwHoverTime=0;
                  TrackMouseEvent(&tr);
     		      InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);                     
                }
                return HTCLIENT;
              } 

              //3. or over chincheta?
              else if(yPos>offset && yPos<offset+17 && xPos>(sizeX-borderSize*2)-25)
              {
                if(chincheta!=OVER && chincheta!=OVER2)
                {
                  if(chincheta==DOWN)                 
                      chincheta=OVER2;
                  else if(chincheta==UP)
                      chincheta=OVER;
                  if(menu==OVER)
                      menu=UP;
                  cerrar=UP;
                  minimizar=UP;
                  TRACKMOUSEEVENT tr;
                  tr.cbSize=sizeof(tr);
                  tr.dwFlags=TME_LEAVE;
                  tr.hwndTrack=hwnd;
                  tr.dwHoverTime=0;
                  TrackMouseEvent(&tr);
     		      InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);                     
                }
                return HTCLIENT;
              } 
                            
              //3.5 or over menu?
              else if(yPos>offset && yPos<offset+17 && xPos>35 && xPos<75)
              {
                if(menu!=OVER && menu!=OVER2)
                {
                  if(menu==UP)
                      menu=OVER;
                  if(chincheta==OVER)
                      chincheta=UP;
                  else if(chincheta==OVER2)
                      chincheta=DOWN;
                  cerrar=UP;
                  minimizar=UP;
                  TRACKMOUSEEVENT tr;
                  tr.cbSize=sizeof(tr);
                  tr.dwFlags=TME_LEAVE;
                  tr.hwndTrack=hwnd;
                  tr.dwHoverTime=0;
                  TrackMouseEvent(&tr);
     		      InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);                     
                }
                return HTCLIENT;
              } 
                        
              
              //4. Or is it the title bar?      
              else if(yPos<15  && docked==0)
              {
                if(cerrar!=UP || minimizar!=UP)
                {
                  cerrar=UP;
                  minimizar=UP;
                  if(menu==OVER)
                      menu=UP;
     		      InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);                   
                }
                return HTCAPTION;
              }
              
              //5 or the handle next to menu? 
              else if(xPos<30 && yPos<offset+17 && (hasfocus==TRUE || docked==0))
              {
                 return HTCAPTION;    
              }
              
              //6. or the handle next to menu when it's docked
              else if(xPos<30 && yPos<offset+17)
              {
                  return HTCLIENT;
              }
              
              //7. or anywhere else?
              else
              {  
                
                if(cerrar!=UP || minimizar!=UP || chincheta==OVER || chincheta==OVER2 || menu==OVER)
                {
                  cerrar=UP;    
                  minimizar=UP;
                  if(chincheta==OVER)
                      chincheta=UP;
                  if(menu==OVER)
                      menu=UP;
      		      InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);                    
                }   
                return uHitTest;
              }                     
           }
           
           //if the hit is not the client area, then it's the border
               //so i filter out the borders I don't wanna use
           else if(uHitTest==HTLEFT || uHitTest==HTRIGHT || uHitTest==HTBOTTOMLEFT || uHitTest==HTBOTTOMRIGHT || uHitTest==HTTOPLEFT || uHitTest==HTTOPRIGHT)
           return HTCLIENT;
           
           //and anything else
           else
           return uHitTest;
        }     
        break;
        
        
        
        
        /********************** WM_NCPAINT*************************/  
		//this message takes care of painting the bordes
		     //NOTE needs to be modified for variable size borders
        case WM_NCPAINT:
        {
		   //find out sizes
           HDC hdc;
           RECT rect;
           GetWindowRect(hwnd,&rect);
           sizeY=rect.bottom-rect.top; 
           int kk;
		   //get the window's DC
           hdc=GetWindowDC(hwnd);
           //get tthe bmp
           HDC MemDC= CreateCompatibleDC(hdc);
           SelectObject(MemDC,bm);         
           //get the colors
           COLORREF c1,c2;
           c1=GetPixel(MemDC,92,168);
           c2=GetPixel(MemDC,93,168);
           //pens
           HPEN p1=CreatePen(PS_SOLID, 1, c1); 
		   HPEN p2=CreatePen(PS_SOLID, 1, c2); 

           //paint borders
           SelectObject(hdc,p1);
           MoveToEx(hdc,0,0,NULL);
           LineTo(hdc,sizeX-1,0);
           LineTo(hdc,sizeX-1,sizeY-1);
           LineTo(hdc,0,sizeY-1);
           LineTo(hdc,0,0);
           
           SelectObject(hdc,p2);
           for(kk=1;kk<borderSize;kk++)
           {
               MoveToEx(hdc,kk,kk,NULL);
               LineTo(hdc,sizeX-(kk+1),kk);
               LineTo(hdc,sizeX-(kk+1),sizeY-(kk+1));
               LineTo(hdc,kk,sizeY-(kk+1));
               LineTo(hdc,kk,kk);                                       
                                       
           }
           		   
		   //title
		   if(docked!=2)
		   {
               for(kk=0;kk<sizeX;kk+=50)
               BitBlt(hdc, kk, 0, 50,borderSize , MemDC, 92, 169, SRCCOPY); 
           
               BitBlt(hdc, 0, 0, borderSize,18 , MemDC, 92, 169, SRCCOPY);          		   
               BitBlt(hdc, sizeX-borderSize, 0, borderSize,18 , MemDC, 92, 169, SRCCOPY);                      		   

               SelectObject(hdc,p1);
               MoveToEx(hdc,sizeX-1,0,NULL);
               LineTo(hdc,sizeX-1,18);
               MoveToEx(hdc,0,0,NULL);
               LineTo(hdc,0,18);
           }
		   		   
		   //realese
           ReleaseDC(hwnd, hdc);
           DeleteDC(MemDC);
           DeleteObject(p1);
           DeleteObject(p2);
           return 0;
        }
        break;
        
    
    
        /********************** WM_PAINT*************************/  
        case WM_PAINT:
        {
           PAINTSTRUCT Ps;
           HDC hDC = BeginPaint(hwnd, &Ps);
           HDC MemDC= CreateCompatibleDC(hDC);
		   int offset=0;				//is it docked?
		   int kk;
           SelectObject(memdc,bkBrush);
           SelectObject(memdc,hpen_bk);
           Rectangle(memdc,0,0,sizeX,sizeY); 
           SelectObject(MemDC,bm);         

		   //if it's not docked, paint title bar and it's buttons
           if(docked==0)
           {
		     //title bar
		     BitBlt(memdc, 0, 0, 250, 15, MemDC, 95, 0, SRCCOPY);
             offset=15;
		     //close button
             if(cerrar==UP)
             BitBlt(memdc, sizeX-19, 1, 12, 12, MemDC, 11, 11, SRCCOPY);
             else if(cerrar==DOWN)
             BitBlt(memdc, sizeX-19, 1, 12, 12, MemDC, 23, 11, SRCCOPY);
             else
             BitBlt(memdc, sizeX-19, 1, 12, 12, MemDC, 35, 11, SRCCOPY);
             //boton minimizar
             if(minimizar==UP)
             BitBlt(memdc, sizeX-32, 1, 12, 12, MemDC, 11, 23, SRCCOPY);
             else if(minimizar==DOWN)
             BitBlt(memdc, sizeX-32, 1, 12, 12, MemDC, 23, 23, SRCCOPY);
             else
             BitBlt(memdc, sizeX-32, 1, 12, 12, MemDC, 35, 23, SRCCOPY);
           }
		   
		   //bg
		   for(kk=0;kk<sizeX;kk+=5)
           BitBlt(memdc, kk, offset, 5, 17, MemDC, 64, 74, SRCCOPY);		   

           //paint chincheta
		   if(chincheta==UP)
           BitBlt(memdc, (sizeX-borderSize*2)-25, offset, 25, 17, MemDC, 133, 32, SRCCOPY);	
           else if(chincheta==OVER)
           BitBlt(memdc, (sizeX-borderSize*2)-25, offset, 25, 17, MemDC, 158, 32, SRCCOPY);
           else 
           BitBlt(memdc, (sizeX-borderSize*2)-25, offset, 25, 17, MemDC, 183, 32, SRCCOPY);		           	   
		   
 
		   //paint handle
           BitBlt(memdc, 0, offset, 30, 17, MemDC, 59, 11, SRCCOPY);
		   
		   
           //paint menu
		   if(menu==UP)
           BitBlt(memdc, 35, offset, 40, 17, MemDC, 11, 35, SRCCOPY);	
           else if(menu==OVER)
           BitBlt(memdc, 35, offset, 40, 17, MemDC, 51, 35, SRCCOPY);
           else 
           BitBlt(memdc, 35, offset, 40, 17, MemDC, 91, 35, SRCCOPY);		           	   


		   
		   
           //double buffering
           BitBlt(hDC, 0, 0, sizeX, 50, memdc, 0, 0, SRCCOPY);           		   

		   //clean up
           DeleteDC(hDC);
           DeleteDC(MemDC);
           EndPaint(hwnd, &Ps);                           
        }             
        break;
        
        
        /*****************************WM_ERASEBKGND***************************/
        case WM_ERASEBKGND:
             
        return 1;
        
        
        /********************** WM_LBUTTONDOWN*************************/ 
        case WM_LBUTTONDOWN:
        {
			  //get coordinates stuff sorted
              int xPos = LOWORD(lParam); 
              int yPos = HIWORD(lParam);
              RECT rec;
              GetWindowRect(hwnd,&rec);
              int offset=0;
			  
			  //if it's docked
              if(docked==0)
              {
                 offset=15;
				 //close button down?
                 if( yPos>1 && yPos<13 && xPos>sizeX-19 && xPos<sizeX-7)
                 cerrar=DOWN;
				 //minimize button down?
                 else if(yPos>1 && yPos<13 && xPos>sizeX-32 && xPos<sizeX-20)
                 minimizar=DOWN;
              }
			  //if anyone is down, track the mouse, we wanna know if the mouse leaves the window
              if(cerrar==DOWN || minimizar==DOWN )
              {
                TRACKMOUSEEVENT tr;
                tr.cbSize=sizeof(tr);
                tr.dwFlags=TME_LEAVE;
                tr.hwndTrack=hwnd;
                tr.dwHoverTime=0;
                TrackMouseEvent(&tr);
              } 
              
              if(chincheta==OVER)
              {
                  chincheta=OVER2; 
                  SetWindowPos(hwnd,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE); 
                  destroyToolTip(ttchincheta);
                  if(docked==2)
                      ttchincheta=addToolTip(hwnd, (sizeX-borderSize)-25, 0+borderSize, 25, 17,"Haz click aqu para \nque la ventana desaparezca \ncuando dejas de prestarle atencin\n");                
                  else
                      ttchincheta=addToolTip(hwnd, (sizeX-borderSize)-25, 15+borderSize, 25, 17,"Haz click aqu para evitar\nque esta ventana se mantenga sobre \nlas de las dems aplicaciones\n");                  

              }                               
              else if(chincheta==OVER2)
              {
                  chincheta=OVER;
                  if(docked!=RIGHT)
                  SetWindowPos(hwnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
                  destroyToolTip(ttchincheta);
                  if(docked==2)
                      ttchincheta=addToolTip(hwnd, (sizeX-borderSize)-25, 0+borderSize, 25, 17,"Haz click aqu para \nque la ventana no desaparezca \ncuando dejas de prestarle atencin\n");                 
                  else
                      ttchincheta=addToolTip(hwnd, (sizeX-borderSize)-25, 15+borderSize, 25, 17,"Haz click aqu para \nmantener la ventana sobre \nlas de las dems aplicaciones\n");                                       

              }
              
              if(menu==OVER)
              {
                  menu=DOWN;
                  ShowMEMenu(rec.left+36+borderSize,rec.top+offset+17+borderSize);
              }

			  //and if we click on the handle next to the menu and we are docked, undock
              if(xPos<30 && yPos<17 && docked==RIGHT)
              {
                SetWindowPos(hwnd,HWND_NOTOPMOST,rec.left+xPos-20,rec.top+yPos-6,sizeX,prevY,0); 
                docked=0;              
              }
			  //repaint, there aren't so many clicks
  		      InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);                                         
        }    
        break;
        
        
        /*********************ME_MENU***********************************/
        case ME_MENU:
            menu=UP;
            switch(wParam)
            {
                case 0:
                     if(acoplar)
                         acoplar=FALSE;
                     else
                         acoplar=TRUE;
                break; 
                
                case 1:
                    InitFonetica(hwnd,flagsf,TRUE); 
                break;
                
                case 2:
                     if(ayudas)
                         ayudas=FALSE;
                     else
                         ayudas=TRUE;
                     setWorking(ayudas);
                break;
                
                case 3:
                    WinHelp(hwnd,"DICCIONARIO DE RIMAS.HLP",HELP_FINDER,0);
                break;
                
                case 4:
                    InitAbout(hwnd);  
                break;
                
                case 5:
                {
                    RECT rect;
                    GetWindowRect(hwnd,&rect);
                    if(docked!=RIGHT)
                    saveSettings(flagsf,rect.right-rect.left,rect.bottom-rect.top,rect.left,rect.top,acoplar,ayudas);                 
                    eraseEverything();                    
                    PostQuitMessage(0);
                }
                break;             
                          
            }
            
            InvalidateRect(hwnd,NULL,FALSE);        
            UpdateWindow(hwnd);                                         
        break;       
        
        /**********************ME_FONETICA*******************************/
        case ME_FONETICA:
             flagsf=getFonetica();
             setFlags(flagsf);
        break;
        
        
        /********************** WM_LBUTTONUP*************************/
        case WM_LBUTTONUP:
        {
		     //close? get Out
             if(cerrar==DOWN)
             {
                    RECT rect;
                    GetWindowRect(hwnd,&rect);
                    if(docked!=RIGHT)
                    saveSettings(flagsf,rect.right-rect.left,rect.bottom-rect.top,rect.left,rect.top,acoplar,ayudas);                 
                    eraseEverything();                    
                    PostQuitMessage(0);
                
             }			 
			 //minimize
             else if(minimizar==DOWN)
             ShowWindow(hwnd, SW_MINIMIZE);
			 

			 
			 //everyone get's up
             cerrar=UP;
             minimizar=UP;
			 //and repainting again, could be optimized but it isn't worth it
    		 InvalidateRect(hwnd,NULL,FALSE);        
             UpdateWindow(hwnd);                                          
        }
        break; 
        
        
        
        /********************** WM_MOVING*************************/ 
		//here's where the docking takes place
        case WM_MOVING:
        {
		
            RECT* rec;	//to catch the rect that comes in lParam
            RECT rect;   //to get window coordinates
            GetWindowRect(hwnd,&rect);
            rec=(RECT*)lParam;
		    //if it's in the right place
            if(rec->left>screenLen-sizeX && rec->left<3000 && acoplar)
            {
			    //and it's not a;lready docked
                if(docked==0)
                {
				  //save the size it has now
                  prevY=rect.bottom-rect.top; 
                  docked=RIGHT; 
				  //make the window topmost
                  SetWindowPos(hwnd,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
                  desactivateTT(ttminimizar);
                  destroyToolTip(ttchincheta);
                  desactivateTT(ttcerrar);
                  tthandle=addToolTip(hwnd, 0+borderSize, 0+borderSize, 30, 17,"Haz click aqu y mueve \nel ratn hacia la izquierda para\ndesacoplar la ventana\n"); 
                  if(chincheta!=DOWN)
                  ttchincheta=addToolTip(hwnd, (sizeX-borderSize)-25, 0+borderSize, 25, 17,"Haz click aqu para \nque la ventana no desaparezca \ncuando dejas de prestarle atencin\n");
                  else
                  ttchincheta=addToolTip(hwnd, (sizeX-borderSize)-25, 0+borderSize, 25, 17,"Haz click aqu para \nque la ventana desaparezca \ncuando dejas de prestarle atencin\n");

                }
				//even if docked, adopt the "docked position"
                rec->top=-3;
                rec->left=screenLen-sizeX+borderSize;
                rec->right=screenLen+borderSize;
                rec->bottom=screenHi+borderSize;
  		        InvalidateRect(hwnd,NULL,FALSE);        
                UpdateWindow(hwnd);                                         

            }  
			//if it IS docked and out of docking area...
            else if(docked!=0)
            {
			  //make window no topmost. 
			  if(chincheta==OVER || chincheta==UP)
              SetWindowPos(hwnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE); 
			  //set previous size
              rec->bottom=rec->top+prevY;
              docked=0;
              destroyToolTip(tthandle);
              destroyToolTip(ttchincheta);
              activateTT(ttcerrar);
              activateTT(ttminimizar);
              if(chincheta!=DOWN)
              ttchincheta=addToolTip(hwnd, (sizeX-borderSize)-25, 15+borderSize, 25, 17,"Haz click aqu para \nmantener la ventana sobre \nlas de las dems aplicaciones\n");
              else
              ttchincheta=addToolTip(hwnd, (sizeX-borderSize)-25, 15+borderSize, 25, 17,"Haz click aqu para evitar\nque esta ventana se mantenga sobre \nlas de las dems aplicaciones\n");
			  //paint
  		      InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);                                           
            }        
        return TRUE;
        }
        
        
        /********************** WM_ACTIVATEAPP************************/ 
		//if a diferent application get's activated, and we are docked, hide it.
        case WM_ACTIVATEAPP:
              if(wParam==FALSE && hasfocus==TRUE && docked==RIGHT && (chincheta==OVER || chincheta==UP))
              {
                 if(!hidden)
                 {              
                    animateHide();
                    hidden=TRUE;
                 }
                 hasfocus=FALSE;
              }
        return 0;
        
        
        
        /********************** WM_NCACTIVATE*************************/ 
		//if we get reactivated, we should know
        case WM_NCACTIVATE:
              if(wParam==TRUE)
              {
                 hasfocus=TRUE;     
              }            
        return DefWindowProc (hwnd, message, wParam, lParam);
        
        
        /********************** ME_MOUSEPOS*************************/ 
		//if we are docked and inactive but the mouse isn't on us, hide. Winodws hooks can't be made global if we are not a DLL
        case ME_MOUSEPOS:
              if(docked!=0 && !hidden && !hasfocus && wParam<screenLen-sizeX-10)
              {
                animateHide();
                hidden=TRUE;                           
              }          
        break;
        
        
        
        /********************** WM_SIZE************************/ 
        case WM_SIZE:
        {
            int kk=32;
            if(docked==2)
            kk=17;
            sizeY=HIWORD(lParam)+borderSize*2;
            NewSizeMEDiccionario(sizeX-borderSize*2,sizeY-(borderSize*2)-kk);   
        }        
        break;
                
        
        /********************** WM_MOUSELEAVE*************************/ 
		//mouse left? make sure all buttons are up
        case WM_MOUSELEAVE:
             {
                cerrar=UP;
                minimizar=UP;
                if(chincheta==OVER)
                    chincheta=UP;
                else if(chincheta==OVER2)
                    chincheta=DOWN;
                if(menu==OVER)
                    menu=UP;
				InvalidateRect(hwnd,NULL,FALSE);        
				UpdateWindow(hwnd);  
             }  
        break; 
        
        
        
        
        /********************** WM_CREATE*************************/ 
        case WM_CREATE:
        {
             RECT client;
             RECT wind;
             GetClientRect(hwnd, &client);
             GetWindowRect(hwnd, &wind);
             borderSize=((wind.right-wind.left)-(client.right-client.left))/2;

			 CreateMEDiccionario(hwnd,32,sizeX-borderSize*2,(sizeY-borderSize*2)-32);
		     InitMenu(hwnd,acoplar,ayudas);
             setFlags(flagsf);	 
             InitFonetica(hwnd,flagsf,FALSE); 
             ttcerrar=addToolTip(hwnd, sizeX-19+borderSize, 1+borderSize, 12, 12,"Cerrar el diccionario\n");
             ttminimizar=addToolTip(hwnd, sizeX-32+borderSize, 1+borderSize, 12, 12,"Minimizar el diccionario\n");
             ttchincheta=addToolTip(hwnd, (sizeX-borderSize*2)-25, 15+borderSize, 25, 17,"Haz click aqu para \nmantener la ventana sobre \nlas de las dems aplicaciones\n");
       }
        break;     
             
             
        /********************** WM_DESTROY*************************/  
        case WM_DESTROY:
            eraseEverything();   
            PostQuitMessage (0);       
            break;
            
            
            

        default:                      
            return DefWindowProc (hwnd, message, wParam, lParam);        
    }
    return 0;
}
