/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/


/* ***********************************************************************************************
*menu.c													
*(c)Eduardo Rodriguez 2005																
*																					
*porpuse:   Temporary file untill a proper menu class is created
*history:	15/11/2005 created									
*********************************************************************************************** */


#include <windows.h>
#include "menu.h"


/*************************
*DATA MEMBERS
**************************/

//info for every instance
typedef struct _menu
{
    int width;             
    int height;  
    int index;
    int fontSize; 
    BOOL ayudas;
    BOOL acoplar;         
    char* fontName;       
    HWND hwnd;             //handle to parent
}menu;


const char g_menu[]="menu";
static HWND thismenu;

extern HDC memdc;
extern HBITMAP bm;

static char *let[6]={"Acoplar a la Ventana","Fontica...","Mostrar Ayudas","Ayuda...","Sobre...","Salir"};
/////////////////////////////////////////////////////////////////////////////////////////
/************************************METHODS ("PRIVATE")********************************/
/////////////////////////////////////////////////////////////////////////////////////////
//set and retrieve window info
static menu*  GetMEMenu(HWND hwnd)
{
    return (menu *)GetWindowLong(hwnd, 0);
}


static void SetMEMenu(HWND hwnd, menu *ccp)
{
    SetWindowLong(hwnd, 0, (LONG)ccp);
}



/*************************
*PAINT
**************************/


static void menuPaint(HWND hwnd, menu *ccp)
{
    //make sure it has been initiliazed 
    if(ccp!=NULL)
    {
         //blabla        
         PAINTSTRUCT Ps;
         HDC hDC = BeginPaint(hwnd, &Ps);
         HDC MemDC= CreateCompatibleDC(hDC);
         COLORREF c1,c2,c3,c4;
         HBRUSH bk1,bk2,bk4;
         HPEN p1,p2,p3,p4;
         HFONT hf = CreateFont(15, 0, 0, 0,0, FALSE, 0, 0, 0, 0, 0, 0, 0, "Times New Roman");   
         int kk;
         SelectObject(MemDC,bm);
         SelectObject(memdc,hf);
 
         c1=GetPixel(MemDC,1,0);
         c2=GetPixel(MemDC,2,0);
         c3=GetPixel(MemDC,3,0);
         c4=GetPixel(MemDC,14,0);       
 
          //paint bg
         bk1=CreateSolidBrush(c1);
         p1=CreatePen(PS_SOLID, 1, c2); 
         bk2=CreateSolidBrush(c3);
         p2=CreatePen(PS_SOLID,1,c3);
         bk4=CreateSolidBrush(c4);
         p4=CreatePen(PS_SOLID,1,c4);
         p3=CreatePen(PS_SOLID,1,c1);
         SelectObject(memdc,bk1);
         SelectObject(memdc,p1);
         Rectangle(memdc,0,0,ccp->width,ccp->height);
         SelectObject(memdc,p3);
         MoveToEx(memdc,1,0,NULL);
         LineTo(memdc,36,0);
 
         //write it
         SetBkColor(memdc, c1);
         SetTextColor(memdc,c2);
         for(kk=0;kk<6;kk++)
         {
                            
            if(kk==ccp->index)
            {
              SetBkColor(memdc, c3); 
              SelectObject(memdc,bk2);
              SelectObject(memdc,p2);
              Rectangle(memdc,20,kk*20+10,169,kk*20+25);
              TextOut(memdc,30,kk*20+10,let[kk],strlen(let[kk]));  
              SetBkColor(memdc, c1); 
              SelectObject(memdc,bk1);
              SelectObject(memdc,p1);                                                         
                              
            }
            else
            TextOut(memdc,30,kk*20+10,let[kk],strlen(let[kk]));                   
                            
         }
         
         //separators
         SelectObject(memdc,p4);
         SelectObject(memdc,bk4);
         MoveToEx(memdc,30,45,NULL);
         LineTo(memdc,169,45);
         MoveToEx(memdc,30,105,NULL);
         LineTo(memdc,169,105);
 
 
         //margin
         Rectangle(memdc,1,5,20,139);
         if(ccp->acoplar)
             BitBlt(memdc, 6, 13,11,11 , MemDC, 235, 32, SRCCOPY); 
         else 
             BitBlt(memdc, 6, 13,11,11 , MemDC, 246, 32, SRCCOPY);                      
          if(ccp->ayudas)
             BitBlt(memdc, 6, 53,11,11 , MemDC, 235, 32, SRCCOPY); 
         else 
             BitBlt(memdc, 6, 53,11,11 , MemDC, 246, 32, SRCCOPY);    
         //double buffer
         BitBlt(hDC, 0, 0,ccp->width,ccp->height , memdc, 0, 0, SRCCOPY);
  

         DeleteObject(bk1);
         DeleteObject(bk2);
         DeleteObject(bk4);
         DeleteObject(p4);
         DeleteObject(p1);
         DeleteObject(p2); 
         DeleteObject(p3);
         DeleteObject(hf);
         DeleteDC(MemDC);
         DeleteDC(hDC);
         EndPaint(hwnd, &Ps);                   
    }     
}






/******************************
*CALLBACK PROCEDURE
*******************************/

LRESULT CALLBACK menuproc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    menu *ccp = GetMEMenu(hwnd);
    switch(msg)
    {
     
        //-------------------------WM_NCHITTEST--------------------------------       
        case WM_NCHITTEST:
        {
             //check who is the mouse over and paint if necessary
             UINT uHitTest = DefWindowProc(hwnd, WM_NCHITTEST, wParam, lParam);
             int yPos = HIWORD(lParam);
             RECT wind; 
             GetWindowRect(hwnd,&wind);
             if( uHitTest==HTCLIENT)
             { 
                //compute element 
                
                int formerElement=ccp->index;
                ccp->index=(((yPos-wind.top)-10)/20);
                if(yPos-wind.top<10)
                ccp->index=-1;
                if(formerElement!=ccp->index)
                {
                	InvalidateRect(hwnd,NULL,FALSE);        
                    UpdateWindow(hwnd);                                                        
                }
             }
             return uHitTest;
        }      
        break; 
        
        
        //--------------------------WM_NCAVTIVATE----------------------------------
        case WM_NCACTIVATE:
             if(wParam==FALSE)
             {
                 ShowWindow(hwnd,SW_HIDE);
                 ccp->index=-1;
                 SendMessage(ccp->hwnd,ME_MENU,-1,0);
             }
        break; 
        
        
        //------------------------WM_LBUTTONDOWN-------------------------------------
         case WM_LBUTTONUP:
             if(ccp->index==0)
             {
                 if(ccp->acoplar)ccp->acoplar=FALSE;
                 else
                     ccp->acoplar=TRUE;
             }
             else if(ccp->index==2)
             {
                 if(ccp->ayudas)ccp->ayudas=FALSE;
                 else
                     ccp->ayudas=TRUE;
             }
             SendMessage(ccp->hwnd,ME_MENU,ccp->index,0);
             ccp->index=-1;
             ShowWindow(hwnd,SW_HIDE);
         break;
         
         

             
        
         //-------------------------WM_NCDESTROY------------------------------------
         case WM_NCDESTROY:
             free(ccp);
         break;
         
         
         //---------------------------WM_PAINT-------------------------------------
         case WM_PAINT:
             menuPaint(hwnd,ccp);
         break;
         
         
         //----------------------------WM_KEYDOWN-----------------------------------
         case WM_KEYDOWN:
              
           //down arrow
           if(wParam== VK_DOWN)
           {      
                  if(ccp->index<5)ccp->index++;
               	  InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);                                                        
           }
           
           //up arrow
           else if(wParam==VK_UP )
           {
                  if(ccp->index>0)ccp->index--;
               	  InvalidateRect(hwnd,NULL,FALSE);        
                  UpdateWindow(hwnd);                                                        
           }
           
 
         
         
         //-----------------------------WM_CHAR----------------------------------
         case WM_CHAR:
             //if it's return
             if(wParam=='\r')
             {
                 if(ccp->index==0)
                 {
                     if(ccp->acoplar)ccp->acoplar=FALSE;
                     else
                         ccp->acoplar=TRUE;
                 }
                 else if(ccp->index==2)
                 {
                     if(ccp->ayudas)ccp->ayudas=FALSE;
                     else
                         ccp->ayudas=TRUE;
                 }
                 SendMessage(ccp->hwnd,ME_MENU,ccp->index,0);
                 ccp->index=-1;
                 ShowWindow(hwnd,SW_HIDE);                  
             }     
         break;
         
        /*****************************WM_ERASEBKGND***************************/
        case WM_ERASEBKGND:
             
        return 1;
        

         
         
         //blabla    
         default:
         break;
    }
    return DefWindowProc(hwnd, msg, wParam, lParam);
}



///////////////////////////////////////////////////////////////////////////////////////
/******************************METHODS ("PUBLIC")************************************/
//////////////////////////////////////////////////////////////////////////////////////

/*****************************
*REGISTER THE CLASS

return void;
HWND parent: any valid handle;
Should be initialized by Global
********************************/
HWND InitMenu(HWND parent, BOOL acop,BOOL ay)
{ 
    WNDCLASSEX wc;
    int w=170,h=140;
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         =  0;
    wc.lpfnWndProc   = menuproc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = sizeof( menu * );
    wc.hInstance     = GetModuleHandle(0);
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_menu;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);
    RegisterClassEx(&wc); 
    
    thismenu=CreateWindowEx(0,g_menu, "",WS_POPUP ,0, 0, 
        w, h,parent, NULL, GetModuleHandle(0), NULL);  

    menu *ccp = GetMEMenu(thismenu);
    ccp = malloc( sizeof(menu) );
    if(ccp == NULL) return NULL;
    
    // Initialize the CustCtrl structure. 
    ccp->height=h;
    ccp->width=w;
    ccp->hwnd=parent;
    ccp->index=-1;
    ccp->ayudas=ay;
    ccp->acoplar=acop;
     SetMEMenu(thismenu,ccp);
         

    return thismenu;    
        
    
}


void ShowMEMenu(int posX,int posY)
{
    menu *ccp = GetMEMenu(thismenu);  
    SetWindowPos(thismenu,0,posX,posY,ccp->width,ccp->height,0); 
    ShowWindow(thismenu,SW_SHOW);   
   
     
}




